/*////////////////////////////////////////////////////////////////

CREATE DATE_FROM_GMT FUNCTION

Author: 	Bob Carver
Created:	15 Jun 2010

Controls:
1. GMT Date
2. Timezone designation

Outputs
1. Formatted, localize date/time, e.g., "2010-06-15 12:03:24 TUE"

////////////////////////////////////////////////////////////////*/

DROP FUNCTION IF EXISTS DATE_FROM_GMT;

CREATE FUNCTION DATE_FROM_GMT (GMTDate timestamp, TZName varchar(100))
RETURNS varchar(23)
DETERMINISTIC

BEGIN
	RETURN UPPER(DATE_FORMAT(CONVERT_TZ(GMTDate, 'GMT', TZName), '%Y-%m-%d %H:%i:%s %a'));
END;
