/*////////////////////////////////////////////////////////////////

RETRIEVE SPECIFIC LANGUAGE VALUE FOR A TOKEN

Author: 	Bob Carver
Created:	05 Jul 2010

Return a defined language values for a gven language token

////////////////////////////////////////////////////////////////*/

DROP FUNCTION IF EXISTS GET_LANGUAGE_TEXT;

CREATE FUNCTION GET_LANGUAGE_TEXT
(
	parmToken			varchar(50),
	parmLanguageToken	varchar(50)
)
RETURNS varchar(250)

BEGIN

	DECLARE langtext varchar(250);

	SELECT LNGV_Text INTO langtext
	FROM Language_Values
		LEFT JOIN Language_Tokens 		ON LNGV_LNGT_ID = LNGT_ID
		LEFT JOIN Language_Collections	ON LNGT_LNGC_ID = LNGC_ID
		LEFT JOIN Language_Sets		ON LNGV_LNGS_ID = LNGS_ID
		LEFT JOIN Language_Names		ON LNGS_LNGN_ID = LNGN_ID
		WHERE 	UPPER(LNGT_Token) 		= UPPER(parmToken)
		AND 	UPPER(LNGN_NameToken) 	= UPPER(parmLanguageToken);

	RETURN langtext;

END;