
DROP FUNCTION IF EXISTS ORDERED_NAME;

CREATE FUNCTION ORDERED_NAME
(
	ActionContol 	char(2),		# pos 1: S = short version; pos 2: F(irst) or L(ast) sequence
	FirstName 		varchar(100), 
	MiddleName 		varchar(50),
	LastName 		varchar(100),
	NameSuffix 		varchar(15),
	NickName 		varchar(100)
) 
RETURNS varchar(500)

BEGIN 

SET @specials	= 'DR.MD.LLD.PHD.THD.JD.OD.DO.DC.DD.NMD.DMD.DDS.DVM.DSC.EDD.RPH.JD';
SET @result  	= '';
SET @newsuffix	= '';
SET @salutation	= '';
SET @charIndex	= 1;

# If we want the first name to come first...

IF UPPER(RIGHT(ActionContol,1)) = 'F' THEN
                	
	First_Name_First: BEGIN
			
		# should we prefix the result with "Dr"?
		
		IF TRIM(NameSuffix) != '' THEN
			Check_Suffix: BEGIN
				WHILE @charIndex <= LENGTH(NameSuffix) DO
					IF SUBSTRING(NameSuffix, @charIndex, 1) != '.' AND SUBSTRING(NameSuffix, @charIndex, 1) != ' ' THEN
						SET @newsuffix = CONCAT(@newsuffix, UPPER(SUBSTRING(NameSuffix, @charIndex, 1)));
					END IF;
					SET @charIndex = @charIndex + 1;
				END WHILE;
				IF INSTR(CONCAT('.', @specials, '.'), CONCAT('.', @newsuffix, '.')) != 0 THEN 
					SET @salutation = 'Dr.';
				END IF;
			END Check_Suffix;
		END IF;	

		IF @salutation != '' THEN SET @result = CONCAT(@salutation, ' '); END IF;
		
		# If what we want is a full name...
		
		IF UPPER(LEFT(ActionContol,1)) != 'S' THEN
		
			FirstFirst_Long_Name: BEGIN
        		IF TRIM(FirstName) != '' THEN 
        			SET @result = CONCAT(@result, TRIM(FirstName), ' ');
				END IF;
				IF TRIM(MiddleName) != '' THEN 
        			SET @result = CONCAT(@result, TRIM(MiddleName), ' ');
				END IF;
        		IF TRIM(NickName) != '' THEN
        			SET @result = CONCAT(@result, '"', TRIM(NickName), '" ');
				END IF;
				IF TRIM(LastName) != '' THEN
        			SET @result = CONCAT(@result, TRIM(LastName));
				END IF;
        		IF TRIM(NameSuffix) != '' AND UPPER(TRIM(NameSuffix)) != 'DR' AND UPPER(TRIM(NameSuffix)) != 'DR.' THEN
        			BEGIN			
            			IF @salutation = '' THEN 
							SET @result = CONCAT(@result, ', ', TRIM(NameSuffix));
            			ELSE 
							IF @salutation != TRIM(NameSuffix) THEN
    							SET @result = CONCAT(@result, ' (', TRIM(NameSuffix), ')');
							END IF;
    					END IF;
        			END;
				END IF;
			END FirstFirst_Long_Name;
			
		
		# If what we want is a short name...
		
		ELSE
		
			FirstFirst_Short_Name: BEGIN
        		IF TRIM(NickName) != '' THEN
        			SET @result = CONCAT(@result, TRIM(NickName), ' ');
				END IF;
        		IF @result = '' AND TRIM(FirstName) != '' THEN
        			SET @result = CONCAT(@result, TRIM(FirstName), ' ');
				END IF;
				IF TRIM(LastName) != '' THEN
        			SET @result = CONCAT(@result, TRIM(LastName));
				END IF;
			END FirstFirst_Short_Name;
			
		END IF;
	
	END First_Name_First;
			
# If we want the last name to come first...

ELSE

	Last_Name_First: BEGIN
		
		IF UPPER(LEFT(ActionContol,1)) != 'S' THEN
		
			LastFirst_Long_Name: BEGIN
				IF TRIM(LastName) != '' THEN
					SET @result = CONCAT(TRIM(LastName), ', ', TRIM(FirstName));
				END IF;
                IF TRIM(MiddleName) != '' THEN
					SET @result = CONCAT(@result, ' ', TRIM(MiddleName));
				END IF;
		 		IF TRIM(NickName) != '' THEN
					SET @result = CONCAT(@result, ' "', TRIM(NickName), '"');
				END IF;
				IF TRIM(NameSuffix) != '' THEN
					SET @result = CONCAT(@result, ', ', TRIM(NameSuffix));
				END IF;
			END LastFirst_Long_Name;
			
		ELSE
		
			LastFirst_Short_Name: BEGIN
				IF TRIM(LastName) != '' THEN
					SET @result = CONCAT(TRIM(LastName), ', ', TRIM(FirstName));
				END IF;
		 		IF TRIM(NickName) != '' THEN
					SET @result = CONCAT(@result, TRIM(NickName));
				END IF;
			END LastFirst_Short_Name;

		END IF;		

	END Last_Name_First;

END IF;

RETURN @result;
 
END;