<?php

// get configuration data
include("../Helpers/config.php");

// light the fires 'n' check the tires
include("adminlib.php");

// bootstrap some language settings until we can get the data loaded
if (!isset($QUERY_FAILURE)) 		{$QUERY_FAILURE 		= "Query failure";}
if (!isset($BAD_DB_CONNECT))		{$BAD_DB_CONNECT		= "Unable to connect to the MAESS database.";}
if (!isset($ERROR_REASON_PREFIX))	{$ERROR_REASON_PREFIX 	= "Reason";}
if (!isset($LABEL_DELIM))			{$LABEL_DELIM 			= ":";}
if (!isset($LANG_NAMES_INSERTED))	{$LANG_NAMES_INSERTED 	= "Names inserted";}
if (!isset($LANG_NAMES_UPDATED))	{$LANG_NAMES_UPDATED 	= "Names updated";}
if (!isset($LANG_SETS_INSERTED))	{$LANG_SETS_INSERTED 	= "Sets inserted";}
if (!isset($LANG_SETS_UPDATED))	{$LANG_SETS_UPDATED 	= "Sets updated";}
if (!isset($LANG_COLLS_INSERTED))	{$LANG_COLLS_INSERTED 	= "Subsets inserted";}
if (!isset($LANG_COLLS_UPDATED))	{$LANG_COLLS_UPDATED 	= "Subsets updated";}
if (!isset($LANG_TOKENS_INSERTED))	{$LANG_TOKENS_INSERTED 	= "Tokens inserted";}
if (!isset($LANG_TOKENS_UPDATED))	{$LANG_TOKENS_UPDATED 	= "Tokens updated";}
if (!isset($LANG_VALS_INSERTED))	{$LANG_VALS_INSERTED 	= "Values inserted";}
if (!isset($LANG_VALS_UPDATED))	{$LANG_VALS_UPDATED 	= "Values updated";}

// initiate the database connection
$dbconn = my_db_connect($database_host, $database_name, $database_username, $database_password);

// LOAD DEFAULT LANGUAGE DATA

// some field limits (sync with schema)
define("LNGN_NAME_LENGTH" 		,   20);
define("LNGN_NAMETOKEN_LENGTH"	,   25);
define("LNGC_NAME_LENGTH"		,   25);
define("LNGC_DESC_LENGTH"		,  250);
define("LNGT_TOKEN_LENGTH"		,   50);
define("LNGT_NOTES_LENGTH"		,  250);
define("LNGV_TEXT_LENGTH"		,  250);
define("LNGV_TIP_LENGTH"		,65536);

// some counters
$names_inserted 		=
$names_updated  		=
$collections_inserted	=
$collections_updated	=
$tokens_inserted		=
$tokens_updated			=
$sets_inserted			=
$sets_updated			=
$values_inserted		=
$values_updated			= 0;

// access the default language XML file
$xml = simplexml_load_file("defaultlanguages.xml");
foreach ($xml->children() as $datatype)
  {
  // loops through each languages category
  foreach ($datatype->children() as $dataelement)
  	{
    // first collect each category's field values
    unset ($attrarray);
    foreach ($dataelement->attributes() as $attr => $val) {$attrarray[strtolower($attr)] = addslashes(trim($val));}
    // determine what to do with them
    switch ($dataelement->getName())
    	{
        ////////////////////////////////
    	// handle language names here //
        ////////////////////////////////
        case "language":

        	if (!array_key_exists('tag',$attrarray) || !array_key_exists('nametoken',$attrarray))
            {Generate_DataLoad_Error($attrarray, "language", ""); break;}
				if (!preg_match(VARNAME_PATTERN, $attrarray['nametoken']))
    		{Generate_DataLoad_Error($attrarray, "language", "one or more language tokens contain invalid characters"); break;}

				// seq may or may not be present; -1 indicates not present
				$seq = -1;
				if (array_key_exists('seq',$attrarray) && +$attrarray['seq'] < DATA_SEQUENCE_CEILING) {$seq = +$attrarray['seq'];}

				// see if language name already in place (and get current sequence value along the way)
				$query = "SELECT LNGN_ID, LNGN_Sequence FROM Language_Names WHERE UPPER(LNGN_Tag) = '" . strtoupper($attrarray['tag']) . "'";
				$result = $dbconn->query ($query) or Fatal_SQL_Error($query);

				// was it there?
				if ($result->num_rows == 0) {$langid = 0;}
				else
				{
            	$row 	= $result->fetch_array(MYSQLI_ASSOC);
            	$langid = $row['LNGN_ID'];
					$seq 	= $seq == -1 ? $row['LNGN_Sequence'] : $seq;
				}
				// add or update the entry
				if ($langid == 0) {$names_inserted++;} else {$names_updated++;}
				$query = "CALL LNGN_Update ($langid,$seq,'" . substr($attrarray['tag'],0,LNGN_NAME_LENGTH) . "','" . substr($attrarray['nametoken'],0,LNGN_NAMETOKEN_LENGTH) . "','{$rsvusername['setup']}','{$ipbins[0]}','{$ipbins[1]}');";
            if (!$dbconn->multi_query ($query)) {Fatal_SQL_Error($query);}
            // get the returned LNGN_ID
            do { if ($result = $dbconn->use_result()) { while ($row = $result->fetch_row()) { $langid = $row[0]; } } } while ($dbconn->next_result());
        	break;

        //////////////////////////////////////
    	// handle language collections here //
        //////////////////////////////////////
        case "subset":

        	if (!array_key_exists('name',$attrarray))
            {Generate_DataLoad_Error($attrarray, "collection", ""); break;}

				// seq may or may not be present; -1 indicates not present
				$seq = -1;
				if (array_key_exists('seq',$attrarray) && +$attrarray['seq'] < DATA_SEQUENCE_CEILING) {$seq = +$attrarray['seq'];}

				// see if collection already in place (and get current sequence value along the way)
				$query  = "SELECT LNGC_ID, LNGC_Sequence FROM Language_Collections WHERE UPPER(LNGC_Name) = '" . strtoupper($attrarray['name']) . "'";
				$result = $dbconn->query ($query) or Fatal_SQL_Error($query);

				// was it there?
				if ($result->num_rows == 0) {$collid = 0;}
				else
				{
            	$row 	= $result->fetch_array(MYSQLI_ASSOC);
            	$collid = $row['LNGC_ID'];
					$seq 	= $seq == -1 ? $row['LNGC_Sequence'] : $seq;
				}

				// add or update the entry
				if ($collid == 0) {$collections_inserted++;} else {$collections_updated++;}
				$query = "CALL LNGC_Update ($collid,$seq,'". substr($attrarray['name'],0,LNGC_NAME_LENGTH) . "','" . substr($attrarray['desc'],0,LNGC_DESC_LENGTH) . "','{$rsvusername['setup']}','{$ipbins[0]}','{$ipbins[1]}');";
            if (!$dbconn->multi_query ($query)) {Fatal_SQL_Error($query);}
            // get the returned LNGC_ID
            do { if ($result = $dbconn->use_result()) { while ($row = $result->fetch_row()) { $collid = $row[0]; } } } while ($dbconn->next_result());
        	break;

        /////////////////////////////////
        // handle language values here //
        /////////////////////////////////
    	case "langval":

        	if (!array_key_exists('language',$attrarray) || !array_key_exists('subset',$attrarray) || !array_key_exists('token',$attrarray) || !array_key_exists('value',$attrarray))
            {Generate_DataLoad_Error($attrarray, "langval", ""); break;}
				if (!preg_match(VARNAME_PATTERN, $attrarray['token']))
    		{Generate_DataLoad_Error($attrarray, "langval", "one or more language tokens contain invalid characters"); break;}

				// seq may or may not be present; -1 indicates not present
				$seq = -1;
				if (array_key_exists('seq',$attrarray) && +$attrarray['seq'] < DATA_SEQUENCE_CEILING) {$seq = +$attrarray['seq'];}

				// is language on file?
				$query = "SELECT LNGN_ID, LNGN_Tag FROM Language_Names WHERE UPPER(LNGN_Tag) = '" . strtoupper($attrarray['language']) . "'";
				$result = $dbconn->query ($query) or Fatal_SQL_Error($query);

				// if not there, abort
				if ($result->num_rows == 0) {Generate_DataLoad_Error($attrarray, "langval", "language not found"); break;}

				// found, get LNGN_ID of language
				$row 	= $result->fetch_array(MYSQLI_ASSOC);
            $langid = $row['LNGN_ID'];

				// if this is not English LNGN, ignore seq option
				if ($row['LNGN_Tag'] != 'en-us') {$seq = -1;}

				// has required LNGS instance already been loaded?
				$query = "SELECT LNGS_ID FROM Language_Sets WHERE LNGS_LNGN_ID = $langid AND LNGS_OPRS_ID IS NULL";
				$result = $dbconn->query ($query) or Fatal_SQL_Error($query);

				// if not there, store it now
				if ($result->num_rows == 0)
				{
					$query  = "CALL LNGS_Insert ($langid, NULL)";
					$result = $dbconn->multi_query ($query) or Fatal_SQL_Error($query);
            	do { if ($result = $dbconn->use_result()) { while ($row = $result->fetch_row()) { $setid = $row[0]; } } } while ($dbconn->next_result());
					$sets_inserted++;
				}
				else
				{
					$row 	= $result->fetch_array(MYSQLI_ASSOC);
           	 	$setid  = $row['LNGS_ID'];
				}

				// collection must be on file
				$query = "SELECT LNGC_ID FROM Language_Collections WHERE UPPER(LNGC_Name) = '" . strtoupper($attrarray['subset']) . "'";
				$result = $dbconn->query ($query) or Fatal_SQL_Error($query);
				if ($result->num_rows == 0) {Generate_DataLoad_Error($attrarray, "langval", "subset not found"); break;}

				// get the LNGC key
				$row 	= $result->fetch_array(MYSQLI_ASSOC);
            $subsetid = $row['LNGC_ID'];

				// check if token loaded; if not, add it now
				$query = "SELECT LNGT_ID, LNGT_Sequence, LNGT_LNGC_ID FROM Language_Tokens WHERE UPPER(LNGT_Token) = '" . strtoupper($attrarray['token']) . "'";
				$result = $dbconn->query ($query) or Fatal_SQL_Error($query);

				// was it there?
				if ($result->num_rows == 0) {$tokenid = 0;}
				else
				{
    			// NOTE: the token is already there, we must ensure that we're not about to
					// inadvertantly reassign it to a different collection (subset). So, at this
					// point we must reject any langval item for which (1) the token
					// is already in present but is (2) connected to a different collection (subset).
					// However, another ambuguity must be considered: how to handle a seq attribute
					// that may be present with a second langval entry, referencing the same token,
					// of the same subset? Should we preserve the seq # of the existing token, or
					// allow it to be overridden? The latter is adopted so that, minimally, if
					// reprocessing a simple, single language set we have a way to alter the seq #.
					// This does mean that if there's a <langval ...subset="A" token="T" seq="10" ...>
					// and a second <langval ...subset="A" token="T" seq="15" ...>, the seq="15" will;
					// take precedence.

            	$row 	 = $result->fetch_array(MYSQLI_ASSOC);
            	$tokenid = $row['LNGT_ID'];
					$seq 	 = $seq == -1 ? $row['LNGT_Sequence'] : $seq;

					if ($row['LNGT_LNGC_ID'] != $subsetid) {Generate_DataLoad_Error($attrarray, "langval", "the token was previously assigned to a diferent subset"); break;}
				}
				if ($seq == -1) {$seq = 0;}

				// add or update the entry
				if ($tokenid == 0) {$tokens_inserted++;} else {$tokens_updated++;}
				$query = "CALL LNGT_Update ($tokenid,$subsetid,$seq,'". substr($attrarray['token'],0,LNGT_TOKEN_LENGTH) . "','" . substr($attrarray['notes'],0,LNGT_NOTES_LENGTH) . "','{$rsvusername['setup']}','{$ipbins[0]}','{$ipbins[1]}');";
				if (!$dbconn->multi_query ($query)) {Fatal_SQL_Error($query);}
            // get the returned LNGT_ID
            do { if ($result = $dbconn->use_result()) { while ($row = $result->fetch_row()) { $tokenid = $row[0]; } } } while ($dbconn->next_result());

				// finally .. prepare to handle the value; need it's key first
				$query  = "SELECT LNGV_ID FROM Language_Values"
						. "\nLEFT JOIN Language_Sets ON LNGS_ID = LNGV_LNGS_ID"
						. "\nLEFT JOIN Language_Tokens ON LNGT_ID = LNGV_LNGT_ID"
						. "\nWHERE UPPER(LNGT_Token) = '" . strtoupper($attrarray['token']) . "'"
						. "\nAND LNGS_ID = $setid";
				$result = $dbconn->query ($query) or Fatal_SQL_Error($query);
				if ($result->num_rows == 0) {$valid = 0;}
				else
				{
            	$row   = $result->fetch_array(MYSQLI_ASSOC);
            	$valid = $row['LNGV_ID'];
				}
				// add or update the entry
				if ($valid == 0) {$values_inserted++;} else {$values_updated++;}
				$query = "CALL LNGV_Update ($valid,$setid,$tokenid,'". substr($attrarray['value'],0,LNGV_TEXT_LENGTH) . "','" . substr($attrarray['tip'],0,LNGV_TIP_LENGTH) . "','{$rsvusername['setup']}','{$ipbins[0]}','{$ipbins[1]}');";
            if (!$dbconn->multi_query ($query)) {Fatal_SQL_Error($query);}
            // get the returned LNGV_ID
            do { if ($result = $dbconn->use_result()) { while ($row = $result->fetch_row()) { $valid = $row[0]; } } } while ($dbconn->next_result());
        	break;
   		}
    }
  }

// now load the Common and Setup collections

	Get_Language_Settings ('LANG_US_ENGLISH', array('Common', 'Setup'));

// report results

  echo nl2br("$LANG_NAMES_INSERTED	= $names_inserted"
			 . "\n$LANG_NAMES_UPDATED	= $names_updated"
			 . "\n$LANG_COLLS_INSERTED	= $collections_inserted"
			 . "\n$LANG_COLLS_UPDATED	= $collections_updated"
			 . "\n$LANG_TOKENS_INSERTED	= $tokens_inserted"
			 . "\n$LANG_TOKENS_UPDATED	= $tokens_updated"
			 . "\n$LANG_SETS_INSERTED	= $sets_inserted"
			 . "\n$LANG_SETS_UPDATED	= $sets_updated"
			 . "\n$LANG_VALS_INSERTED	= $values_inserted"
			 . "\n$LANG_VALS_UPDATED	= $values_updated");

?>