<?php

// get configuration data
include("../Helpers/config.php");

// light the fires 'n' check the tires
include("adminlib.php");

// bootstrap some language settings until we can get the data loaded
if (!isset($QUERY_FAILURE)) 		{$QUERY_FAILURE 		= "Query failure";}
if (!isset($BAD_DB_CONNECT))		{$BAD_DB_CONNECT		= "Unable to connect to the MAESS database.";}
if (!isset($ERROR_REASON_PREFIX))	{$ERROR_REASON_PREFIX 	= "Reason";}
if (!isset($LABEL_DELIM))			{$LABEL_DELIM 			= ":";}
if (!isset($LANG_COLLS_INSERTED))	{$LANG_COLLS_INSERTED 	= "Collections inserted";}
if (!isset($LANG_COLLS_UPDATED))	{$LANG_COLLS_UPDATED 	= "Collections updated";}
if (!isset($LANG_TOKENS_INSERTED))	{$LANG_TOKENS_INSERTED 	= "Tokens inserted";}
if (!isset($LANG_TOKENS_UPDATED))	{$LANG_TOKENS_UPDATED 	= "Tokens updated";}
if (!isset($LANG_VALS_INSERTED))	{$LANG_VALS_INSERTED 	= "Values inserted";}
if (!isset($LANG_VALS_UPDATED))	{$LANG_VALS_UPDATED 	= "Values updated";}

// initiate the database connection
$dbconn = my_db_connect($database_host, $database_name, $database_username, $database_password);
if (!$dbconn) { die ($BAD_DB_CONNECT . " " . $ERROR_REASON_PREFIX . LABEL_DELIM . " " . mysql_error()); }

// LOAD DEFAULT LANGUAGE DATA

// some field limits (sync with schema)
define("SYSC_NAME_LENGTH" 		, 25);
define("SYSC_DESC_LENGTH"		,250);
define("SYST_TOKEN_LENGTH"		, 50);
define("SYST_NOTES_LENGTH"		,250);
define("SYSV_VALUE_LENGTH"		,250);

define("SYSV_INTVALUE_LIMIT"	,16777215); // equivalent of unsigned mediumint

// some counters
$collections_inserted	=
$collections_updated	=
$tokens_inserted		=
$tokens_updated			=
$values_inserted		=
$values_updated			= 0;

// access the default language XML file
$xml = simplexml_load_file("defaultsettings.xml");
foreach ($xml->children() as $datatype)
  {
  // loops through each languages category
  foreach ($datatype->children() as $dataelement)
  	{
    // first collect each category's field values
    unset ($attrarray);
    foreach ($dataelement->attributes() as $attr => $val) {$attrarray[strtolower($attr)] = addslashes(trim($val));}
    // determine what to do with them
    switch ($dataelement->getName())
    	{
        ///////////////////////////////////////
    	// handle collections (subsets) here //
        ///////////////////////////////////////
        case "subset":

        	if (!array_key_exists('name',$attrarray))
            {Generate_DataLoad_Error($attrarray, "subset", ""); break;}

				// seq may or may not be present; -1 indicates not present
				$seq = -1;
				if (array_key_exists('seq',$attrarray) && +$attrarray['seq'] < DATA_SEQUENCE_CEILING) {$seq = +$attrarray['seq'];}

				// see if subset name already in place (and get current sequence value along the way)
				$query = "SELECT SYSC_ID, SYSC_Sequence FROM System_Collections WHERE UPPER(SYSC_Name) = '" . strtoupper($attrarray['name']) . "'";
				$result = $dbconn->query ($query) or Fatal_SQL_Error($query);

				// was it there?
				if ($result->num_rows == 0) {$collid = 0;}
				else
				{
            	$row 	= $result->fetch_array(MYSQLI_ASSOC);
            	$collid = $row['SYSC_ID'];
					$seq 	= $seq == -1 ? $row['SYSC_Sequence'] : $seq;
				}
				// add or update the entry
				if ($collid == 0) {$collections_inserted++;} else {$collections_updated++;}
				$query = "CALL SYSC_Update ($collid,$seq,'" . substr($attrarray['name'],0,SYSC_NAME_LENGTH) . "','" . substr($attrarray['desc'],0,SYSC_DESC_LENGTH) . "','{$rsvusername['setup']}','{$ipbins[0]}','{$ipbins[1]}');";
            if (!$dbconn->multi_query ($query)) {Fatal_SQL_Error($query);}
            // get the returned SYSC_ID
            do { if ($result = $dbconn->use_result()) { while ($row = $result->fetch_row()) { $collid = $row[0]; } } } while ($dbconn->next_result());
				break;

        //////////////////////////
        // handle settings here //
        //////////////////////////
    	case "setting":

        	if (!array_key_exists('subset',$attrarray) || !array_key_exists('token',$attrarray) || !array_key_exists('value',$attrarray) || !array_key_exists('type',$attrarray))
            {Generate_DataLoad_Error($attrarray, "setting", ""); break;}
				if (!preg_match(VARNAME_PATTERN, $attrarray['token']))
    		{Generate_DataLoad_Error($attrarray, "setting", "language token contain invalid characters"); break;}

				// force type uppercase and, if type=B, also force value uppercase
				$attrarray['type'] = strtoupper($attrarray['type']);
				if ($attrarray['type'] == "B") {$attrarray['value'] = strtoupper($attrarray['value']);}

				// do similar stuff for hidden attribute

				if (array_key_exists('hidden',$attrarray))
				{
					$attrarray['hidden'] = strtoupper($attrarray['hidden']);
					if (!($attrarray['hidden'] == "TRUE" || $attrarray['hidden'] == "FALSE")) {Generate_DataLoad_Error($attrarray, "setting", "hidden attribute is invalid"); break;}
				}

				// is type valid?
				if ($attrarray['type'] != "I" && $attrarray['type'] != "B" && $attrarray['type'] != "F" && $attrarray['type'] != "S")
            {Generate_DataLoad_Error($attrarray, "setting", "type attribute is invalid"); break;}

				// is value of correct type?
				if (
            	($attrarray['type'] == "I" && !ctype_digit(substr($attrarray['value'],0,1) == "-" ? substr($attrarray['value'],1) : $attrarray['value']))
					||
					($attrarray['type'] == "B" && !($attrarray['value'] == "TRUE" || $attrarray['value'] == "FALSE"))
					||
					($attrarray['type'] == "F" && !is_numeric($attrarray['value']))
					||
					($attrarray['type'] == "S" && !ctype_print($attrarray['value']))
					)
				{Generate_DataLoad_Error($attrarray, "setting", "value is not of specified type"); break;}

				// is integer value within limits?
				if (abs((int)$attrarray['value']) > SYSV_INTVALUE_LIMIT)
				{Generate_DataLoad_Error($attrarray, "setting", "integer value is out of acceptable range"); break;}

				// seq may or may not be present; -1 indicates not present
				$seq = -1;
				if (array_key_exists('seq',$attrarray) && +$attrarray['seq'] < DATA_SEQUENCE_CEILING) {$seq = +$attrarray['seq'];}

				$hidden = !array_key_exists('hidden',$attrarray) ? 0 : (boolean)$attrarray['hidden'];

				// is collection on file?
				$query = "SELECT SYSC_ID FROM System_Collections WHERE UPPER(SYSC_Name) = '" . strtoupper($attrarray['subset']) . "'";
				$result = $dbconn->query ($query) or Fatal_SQL_Error($query);
				if ($result->num_rows == 0) {Generate_DataLoad_Error($attrarray, "setting", "subset not found"); break;}
				else { $row = $result->fetch_array(MYSQLI_ASSOC); $collid = $row['SYSC_ID']; }

				// check if token loaded
				$query = "SELECT SYST_ID, SYST_SYSC_ID, SYST_Sequence FROM System_Tokens WHERE UPPER(SYST_Token) = '" . strtoupper($attrarray['token']) . "'";
				$result = $dbconn->query ($query) or Fatal_SQL_Error($query);
				if ($result->num_rows == 0) {$tokenid = 0;}
				else
				{
    			// NOTE: the token is already there, we must ensure that we're not about to
					// inadvertantly reassign it to a different language collection (subset).
					// So, at this point we must reject any setting item for which (1) the token
					// is already in present but is (2) connected to a different collection (subset).
					// However, another ambuguity must be considered: how to handle a seq attribute
					// that may be present with a second setting entry, referencing the same token,
					// of the same subset? Should we preserve the seq # of the existing token, or
					// allow it to be overridden? The latter is adopted so that, minimally, if
					// reprocessing a settings collection we have a way to alter the seq #. This does
					// mean that if there's a <setting subset="A" token="T" seq="10" ...> and a second
					// <setting ...subset="A" token="T" seq="15" ...>, the seq="15" will take precedence.

            	$row 	 = $result->fetch_array(MYSQLI_ASSOC);
            	$tokenid = $row['SYST_ID'];
					$seq 	 = $seq == -1 ? $row['SYST_Sequence'] : $seq;

					if ($row['SYST_SYSC_ID'] != $collid) {Generate_DataLoad_Error($attrarray, "setting", "the token was previously assigned to a diferent subset"); break;}
				}

				// add or update the entry
				if ($seq == -1) {$seq = 0;}
				if ($tokenid == 0) {$tokens_inserted++;} else {$tokens_updated++;}
				$query = "CALL SYST_Update ($tokenid,$collid,$hidden,$seq,'" . substr($attrarray['token'],0,SYST_TOKEN_LENGTH) . "','{$attrarray['type']}','" . substr($attrarray['notes'],0,SYST_NOTES_LENGTH) . "','{$rsvusername['setup']}','{$ipbins[0]}','{$ipbins[1]}');";
				if (!$dbconn->multi_query ($query)) {Fatal_SQL_Error($query);}
            // get the returned SYST_ID
            do { if ($result = $dbconn->use_result()) { while ($row = $result->fetch_row()) { $tokenid = $row[0]; } } } while ($dbconn->next_result());

				// add or update the setting value
				$query  = "SELECT SYSV_ID FROM System_Values"
						. "\nLEFT JOIN System_Settings ON SYSS_ID = SYSV_SYSS_ID"
						. "\nLEFT JOIN System_Tokens ON SYST_ID = SYSV_SYST_ID"
						. "\nWHERE UPPER(SYST_Token) = '" . strtoupper($attrarray['token']) . "'"
						. "\nAND SYSS_ID = (SELECT SYSS_ID FROM System_Settings WHERE SYSS_OPRS_ID IS NULL)";
				$result = $dbconn->query ($query) or Fatal_SQL_Error($query);
				if ($result->num_rows == 0)
				{
					$values_inserted++;
					$query = "CALL SYSV_Update (0,NULL,$tokenid,'" . substr($attrarray['value'],0,SYSV_VALUE_LENGTH) . "','{$rsvusername['setup']}','{$ipbins[0]}','{$ipbins[1]}');";
				}
				else
				{
					$values_updated++;
					$row   = $result->fetch_array(MYSQLI_ASSOC);
					$query = "CALL SYSV_Update ({$row['SYSV_ID']},NULL,NULL,'" . substr($attrarray['value'],0,SYSV_VALUE_LENGTH) . "','{$rsvusername['setup']}','{$ipbins[0]}','{$ipbins[1]}');";
				}
				$result = $dbconn->query ($query) or Fatal_SQL_Error($query);
				$result = $dbconn->next_result();
    		break;
   		}
    }
  }

// report results

  echo nl2br(   "$LANG_COLLS_INSERTED	= $collections_inserted"
			 . "\n$LANG_COLLS_UPDATED	= $collections_updated"
			 . "\n$LANG_TOKENS_INSERTED	= $tokens_inserted"
			 . "\n$LANG_TOKENS_UPDATED	= $tokens_updated"
			 . "\n$LANG_VALS_INSERTED	= $values_inserted"
			 . "\n$LANG_VALS_UPDATED	= $values_updated"    );

?>