/*////////////////////////////////////////////////////////////////

INSERT Audit Record

Author: 	Bob Carver
Created:	19 Jun 2010

////////////////////////////////////////////////////////////////*/

DROP PROCEDURE IF EXISTS AUDT_Insert;

CREATE PROCEDURE AUDT_Insert
(
	IN parmType			smallint,
	IN parmUsername		varchar(25),
	IN parmUserIP1		bigint,
	IN parmUserIP2		bigint,
	IN parmID			int,
	IN parmTableCode	char(4),
	IN parmSubID		int,
	IN parmSubTableCode	char(4),
	IN parmDetails		varchar(500)
)
BEGIN
	# insert new audit log entry
	INSERT INTO Audit_Log
		(AUDT_Type, AUDT_TimeStamp,   AUDT_Username, AUDT_UserIP1,                     AUDT_UserIP2,           AUDT_ParentID, AUDT_ParentCode, AUDT_SubordinateID, AUDT_SubordinateCode, AUDT_Details)
	VALUES
		(parmType,  UTC_TIMESTAMP(),  parmUsername,  NULLIF(CONV(parmUserIP1,2,10),0), CONV(parmUserIP2,2,10), parmID,        parmTableCode,   parmSubID,          parmSubTableCode,     parmDetails);
END;
