/*////////////////////////////////////////////////////////////////

Delete System_Changes row

Author: 	Bob Carver
Created:	17 Jul 2010

////////////////////////////////////////////////////////////////*/

DROP PROCEDURE IF EXISTS CHGH_Delete;

CREATE PROCEDURE CHGH_Delete
(
	IN  parmID				mediumint	UNSIGNED,
	IN  parmUSROID			mediumint	UNSIGNED,
	IN  parmUpdateUserIP1	varchar(64),
	IN  parmUpdateUserIP2	varchar(64)
)
BEGIN
	DECLARE oldShortDesc	varchar(50);

	IF EXISTS (SELECT CHGH_ID FROM System_Changes WHERE CHGH_ID = parmID) THEN
		BEGIN
				START TRANSACTION;
				SELECT SUBSTRING(CHGH_ShortDesc,1,50) INTO oldShortDesc FROM System_Changes WHERE CHGH_ID = parmId;
				DELETE FROM System_Changes WHERE CHGH_ID = parmID;
				CALL AUDT_Insert (2, (SELECT USRM_Name FROM Users_Operators INNER JOIN Users_Main ON USRM_ID = USRO_USRM_ID = USRM_ID WHERE USRO_ID = parmUSROID), parmUpdateUserIP1, parmUpdateUserIP2, parmID, 'CHGH', NULL, NULL, oldShortDesc);
				COMMIT;
		END;
	END IF;

	SELECT 0 AS ReturnCode, '' AS MoreInfo;

END;
