
DROP PROCEDURE IF EXISTS CHGH_Update;

CREATE PROCEDURE CHGH_Update
(
	IN parmID				mediumint	UNSIGNED,
	IN parmChangeDate		timestamp,
	IN parmInternalViewOnly	boolean,
	IN parmShortDesc		varchar(100),
	IN parmUpdateUser		varchar(25),
	IN parmUpdateUserIP1	varchar(64),
	IN parmUpdateUserIP2	varchar(64),
	IN parmLongDesc			text,
	IN parmInternalDesc		text
)
BEGIN
	IF parmID = 0 THEN
	# insert new change log entry
		BEGIN
			INSERT INTO System_Changes
			(
				CHGH_ChangeDate,
				CHGH_InternalViewOnly,
				CHGH_ShortDesc,
				CHGH_UpdateUser,
				CHGH_UpdateUserIP1,
				CHGH_UpdateUserIP2,
				CHGH_UpdateTimestamp,
				CHGH_LongDesc,
				CHGH_InternalDesc
			)
			VALUES
			(
				parmChangeDate,
				parmInternalViewOnly,
				parmShortDesc,
				parmUpdateUser,
				NULLIF(CONV(parmUpdateUserIP1,2,10),0),
				CONV(parmUpdateUserIP2,2,10),
				UTC_TIMESTAMP(),
				parmLongDesc,
				parmInternalDesc
			);
			SELECT LAST_INSERT_ID();
		END;
	ELSE
	# update existing change log entry
		BEGIN
			UPDATE System_Changes SET
				CHGH_ChangeDate			= parmChangeDate,
				CHGH_InternalViewOnly	= parmInternalViewOnly,
				CHGH_ShortDesc			= parmShortDesc,
				CHGH_UpdateUser			= parmUpdateUser,
				CHGH_UpdateUserIP1		= NULLIF(CONV(parmUpdateUserIP1,2,10),0),
				CHGH_UpdateUserIP2		= CONV(parmUpdateUserIP2,2,10),
				CHGH_UpdateTimestamp	= UTC_TIMESTAMP(),
				CHGH_LongDesc			= parmLongDesc,
				CHGH_InternalDesc		= parmInternalDesc
			WHERE CHGH_ID				= parmID;
			SELECT parmID;
		END;
	END IF;
END;