/*////////////////////////////////////////////////////////////////

INSERT/UPDATE Language_Collections Table

Author: 	Bob Carver
Created:	02 Feb 2010

Controls:
1. If parmId is negative, then INSERT is done; else UPDATE

////////////////////////////////////////////////////////////////*/

DROP PROCEDURE IF EXISTS LNGC_Update;

CREATE PROCEDURE LNGC_Update
	(
		IN parmID				tinyint		UNSIGNED,
		IN parmSeq				smallint	UNSIGNED,
		IN parmName				varchar(25),
		IN parmDesc				varchar(250),
		IN parmUpdateUser		varchar(25),
		IN parmUpdateUserIP1	varchar(64),
		IN parmUpdateUserIP2	varchar(64)
	)
	BEGIN
		IF parmID = 0 THEN
		# insert new collection
			DoInsert: BEGIN
				INSERT INTO Language_Collections
				(
  				LNGC_Sequence,
					LNGC_Name,
					LNGC_Description,
					LNGC_UpdateUser,
					LNGC_UpdateUserIP1,
					LNGC_UpdateUserIP2,
					LNGC_UpdateTimestamp
				)
				VALUES
				(
					parmSeq,
					parmName,
					parmDesc,
					parmUpdateUser,
					NULLIF(CONV(parmUpdateUserIP1,2,10),0),
					CONV(parmUpdateUserIP2,2,10),
					UTC_TIMESTAMP()
				);
				SELECT LAST_INSERT_ID();
			END DoInsert;
		ELSE
		# update existing collection
			DoUpdate: BEGIN
				UPDATE Language_Collections SET
  				LNGC_Sequence		= parmSeq,
					LNGC_Name			= parmName,
					LNGC_Description	= parmDesc,
					LNGC_UpdateUser		= parmUpdateUser,
					LNGC_UpdateUserIP1	= NULLIF(CONV(parmUpdateUserIP1,2,10),0),
					LNGC_UpdateUserIP2	= CONV(parmUpdateUserIP2,2,10),
					LNGC_UpdateTimestamp= UTC_TIMESTAMP()
				WHERE LNGC_ID			= parmID;
				SELECT parmID;
			END DoUpdate;
		END IF;
	END;
