/*////////////////////////////////////////////////////////////////

Retrieve information needed to generate a language selection list

Author: 	Bob Carver
Created:	10 Feb 2010

Controls:
1. If parmId is negative, then INSERT is done; else UPDATE

////////////////////////////////////////////////////////////////*/

DROP PROCEDURE IF EXISTS LNGN_GetLanguageList;

CREATE PROCEDURE LNGN_GetLanguageList
(
	parmLangToken 	varchar(25),
	parmOPRSID		mediumint	UNSIGNED
)
	BEGIN

		IF parmOPRSID IS NULL THEN
			BEGIN
        		SELECT LNGT_Token, LNGV_Text
                FROM Language_Names
                    INNER JOIN Language_Sets 	ON LNGS_LNGN_ID = LNGN_ID AND LNGS_OPRS_ID IS NULL
                    INNER JOIN Language_Values 	ON LNGV_LNGS_ID = LNGS_ID
                    INNER JOIN Language_Tokens 	ON LNGV_LNGT_ID = LNGT_ID
                WHERE 	LNGT_Token IN (SELECT LNGN_NameToken FROM Language_Names)
                AND 	UPPER(LNGN_NameToken) = UPPER(parmLangToken);
			END;
		ELSE
			BEGIN
        		SELECT LNGT_Token, LNGV_Text
                FROM Language_Names
                    INNER JOIN Language_Sets 	ON LNGS_LNGN_ID = LNGN_ID AND LNGS_OPRS_ID = parmOPRSID
                    INNER JOIN Language_Values 	ON LNGV_LNGS_ID = LNGS_ID
                    INNER JOIN Language_Tokens 	ON LNGV_LNGT_ID = LNGT_ID
                WHERE 	LNGT_Token IN (SELECT LNGN_NameToken FROM Language_Names)
                AND 	UPPER(LNGN_NameToken) = UPPER(parmLangToken);
			END;
		END IF;

	END;
