/*////////////////////////////////////////////////////////////////

INSERT/UPDATE Language_Names Table

Author: 	Bob Carver
Created:	01 Feb 2010

Controls:
1. If parmId is negative, then INSERT is done; else UPDATE

////////////////////////////////////////////////////////////////*/

DROP PROCEDURE IF EXISTS LNGN_Update;

CREATE PROCEDURE LNGN_Update
	(
		IN parmID				tinyint		UNSIGNED,
		IN parmSeq				smallint	UNSIGNED,
		IN parmTag				varchar(20),
		IN parmNameToken		varchar(25),
		IN parmUpdateUser		varchar(25),
		IN parmUpdateUserIP1	varchar(64),
		IN parmUpdateUserIP2	varchar(64)
	)
	BEGIN
		IF parmID = 0 THEN
		# insert new name
			DoInsert: BEGIN
				INSERT INTO Language_Names
				(
  					LNGN_Sequence,
					LNGN_Tag,
					LNGN_NameToken,
					LNGN_UpdateUser,
					LNGN_UpdateUserIP1,
					LNGN_UpdateUserIP2,
					LNGN_UpdateTimestamp
				)
				VALUES
				(
					parmSeq,
					parmTag,
					parmNameToken,
					parmUpdateUser,
					NULLIF(CONV(parmUpdateUserIP1,2,10),0),
					CONV(parmUpdateUserIP2,2,10),
					UTC_TIMESTAMP()
				);
				SELECT LAST_INSERT_ID();
			END DoInsert;
		ELSE
		# update existing name
			DoUpdate: BEGIN
				UPDATE Language_Names SET
  					LNGN_Sequence		= parmSeq,
					LNGN_Tag			= parmTag,
					LNGN_NameToken		= parmNameToken,
					LNGN_UpdateUser		= parmUpdateUser,
					LNGN_UpdateUserIP1	= NULLIF(CONV(parmUpdateUserIP1,2,10),0),
					LNGN_UpdateUserIP2	= CONV(parmUpdateUserIP2,2,10),
					LNGN_UpdateTimestamp= UTC_TIMESTAMP()
				WHERE LNGN_ID			= parmID;
				SELECT parmID;
			END DoUpdate;
		END IF;
	END;
