/*////////////////////////////////////////////////////////////////

INSERT/UPDATE Language_Tokens Table

Author: 	Bob Carver
Created:	02 Feb 2010

Controls:
1. If parmId is negative, then INSERT is done; else UPDATE

////////////////////////////////////////////////////////////////*/

DROP PROCEDURE IF EXISTS LNGT_Update;

CREATE PROCEDURE LNGT_Update
	(
		IN parmID				smallint	UNSIGNED,
		IN parmLNGCID			smallint	UNSIGNED,
		IN parmSeq				smallint	UNSIGNED,
		IN parmToken			varchar(50),
		IN parmNotes			varchar(250),
		IN parmUpdateUser		varchar(25),
		IN parmUpdateUserIP1	varchar(64),
		IN parmUpdateUserIP2	varchar(64)
	)
	BEGIN
		IF parmID = 0 THEN
		# insert new collection
			DoInsert: BEGIN
				INSERT INTO Language_Tokens
				(
  				LNGT_LNGC_ID,
					LNGT_Sequence,
					LNGT_Token,
					LNGT_Notes,
					LNGT_UpdateUser,
					LNGT_UpdateUserIP1,
					LNGT_UpdateUserIP2,
					LNGT_UpdateTimestamp
				)
				VALUES
				(
					parmLNGCID,
					parmSeq,
					parmToken,
					parmNotes,
					parmUpdateUser,
					NULLIF(CONV(parmUpdateUserIP1,2,10),0),
					CONV(parmUpdateUserIP2,2,10),
					UTC_TIMESTAMP()
				);
				SELECT LAST_INSERT_ID();
			END DoInsert;
		ELSE
		# update existing collection
			DoUpdate: BEGIN
				UPDATE Language_Tokens SET
  				LNGT_LNGC_ID		= parmLNGCID,
					LNGT_Sequence		= parmSeq,
					LNGT_Token			= parmToken,
					LNGT_Notes			= parmNotes,
					LNGT_UpdateUser		= parmUpdateUser,
					LNGT_UpdateUserIP1	= NULLIF(CONV(parmUpdateUserIP1,2,10),0),
					LNGT_UpdateUserIP2	= CONV(parmUpdateUserIP2,2,10),
					LNGT_UpdateTimestamp= UTC_TIMESTAMP()
				WHERE LNGT_ID			= parmID;
				SELECT parmID;
			END DoUpdate;
		END IF;
	END;
