/*////////////////////////////////////////////////////////////////

INSERT/UPDATE Language_Values Table

Author: 	Bob Carver
Created:	02 Feb 2010

Controls:
1. If parmId is negative, then INSERT is done; else UPDATE

////////////////////////////////////////////////////////////////*/

DROP PROCEDURE IF EXISTS LNGV_Update;

CREATE PROCEDURE LNGV_Update
(
	IN parmID				mediumint	UNSIGNED,
	IN parmLNGSID			smallint	UNSIGNED,
	IN parmLNGTID			smallint	UNSIGNED,
	IN parmText				varchar(250),
	IN parmTip				text,
	IN parmUpdateUser		varchar(25),
	IN parmUpdateUserIP1	varchar(64),
	IN parmUpdateUserIP2	varchar(64)
)
	BEGIN
		IF parmID = 0 THEN
		# insert new language value
			DoInsert: BEGIN
				INSERT INTO Language_Values
				(
  				LNGV_LNGS_ID,
					LNGV_LNGT_ID,
					LNGV_Text,
					LNGV_Tooltip,
					LNGV_UpdateUser,
					LNGV_UpdateUserIP1,
					LNGV_UpdateUserIP2,
					LNGV_UpdateTimestamp
				)
				VALUES
				(
					parmLNGSID,
					parmLNGTID,
					parmText,
					parmTip,
					parmUpdateUser,
					NULLIF(CONV(parmUpdateUserIP1,2,10),0),
					CONV(parmUpdateUserIP2,2,10),
					UTC_TIMESTAMP()
				);
				SELECT LAST_INSERT_ID();
			END DoInsert;
		ELSE
		# update existing language value
			DoUpdate: BEGIN
				UPDATE Language_Values SET
  				LNGV_LNGS_ID		= parmLNGSID,
					LNGV_LNGT_ID		= parmLNGTID,
					LNGV_Text			= parmText,
					LNGV_Tooltip		= parmTip,
					LNGV_UpdateUser		= parmUpdateUser,
					LNGV_UpdateUserIP1	= NULLIF(CONV(parmUpdateUserIP1,2,10),0),
					LNGV_UpdateUserIP2	= CONV(parmUpdateUserIP2,2,10),
					LNGV_UpdateTimestamp= UTC_TIMESTAMP()
				WHERE LNGV_ID			= parmID;
				SELECT parmID;
			END DoUpdate;
		END IF;
	END;
