/*////////////////////////////////////////////////////////////////

Delete Countries row

Author: 	Bob Carver
Created:	24 Jun 2010

////////////////////////////////////////////////////////////////*/

DROP PROCEDURE IF EXISTS NATN_Delete;

CREATE PROCEDURE NATN_Delete
	(
		IN  parmID				smallint	UNSIGNED,
		IN  parmUSROID			mediumint	UNSIGNED,
		IN  parmUpdateUserIP1	varchar(64),
		IN  parmUpdateUserIP2	varchar(64)
	)
	BEGIN
		DECLARE oldNameToken	varchar(50);
		DECLARE oldCode			char(2);

        IF EXISTS (SELECT NATN_ID FROM COuntries_Main WHERE NATN_ID = parmID) THEN
			BEGIN
				START TRANSACTION;
				SELECT NATN_NameToken, NATN_Code INTO oldNameToken, oldCode FROM Countries_Main WHERE NATN_ID = parmID;
       			DELETE FROM Countries_Main WHERE NATN_ID = parmID;
        		CALL AUDT_Insert (2, (SELECT USRM_Name FROM Users_Operators INNER JOIN Users_Main ON USRM_ID = USRO_USRM_ID = USRM_ID WHERE USRO_ID = parmUSROID), parmUpdateUserIP1, parmUpdateUserIP2, parmID, 'NATN', NULL, NULL, CONCAT(oldNameToken, ' (', oldCode, ')'));
        		COMMIT;
			END;
        END IF;

        SELECT 0 AS ReturnCode, '' AS MoreInfo;

	END;
