
DROP PROCEDURE IF EXISTS NATN_Update;

CREATE PROCEDURE NATN_Update
	(
		IN parmID				smallint	UNSIGNED,
		IN parmCode				char(2),
		IN parmISO3				char(3),
		IN parmFIPS				char(2),
		IN parmParent			smallint,
		IN parmStateLength		tinyint,
		IN parmNameToken		varchar(50),
		IN parmStateToken		varchar(50),
		IN parmZipToken			varchar(50),
		IN parmUpdateUser		varchar(25),
		IN parmUpdateUserIP1	varchar(64),
		IN parmUpdateUserIP2	varchar(64)
	)
	BEGIN
		IF parmID = 0 THEN
		# insert new country
			BEGIN
				INSERT INTO Countries_Main
				(
					NATN_Code,
					NATN_Code_ISO3,
					NATN_Code_FIPS,
					NATN_PseudoParent,
					NATN_StateCodeLength,
					NATN_NameToken,
					NATN_StateToken,
					NATN_ZipToken,
					NATN_UpdateUser,
					NATN_UpdateUserIP1,
					NATN_UpdateUserIP2,
					NATN_UpdateTimestamp
				)
				VALUES
				(
					parmCode,
					parmISO3,
					parmFIPS,
					parmParent,
					parmStateLength,
					parmNameToken,
					parmStateToken,
					parmZipToken,
					parmUpdateUser,
					NULLIF(CONV(parmUpdateUserIP1,2,10),0),
					CONV(parmUpdateUserIP2,2,10),
					UTC_TIMESTAMP()
				);
				SELECT LAST_INSERT_ID();
			END;
		ELSE
		# update existing country
			BEGIN
				UPDATE Countries_Main SET
					NATN_Code				= parmCode,
					NATN_Code_ISO3			= parmISO3,
					NATN_Code_FIPS			= parmFIPS,
					NATN_PseudoParent		= parmParent,
					NATN_StateCodeLength	= parmStateLength,
					NATN_NameToken			= parmNameToken,
					NATN_StateToken			= parmStateToken,
					NATN_ZipToken			= parmZipToken,
					NATN_UpdateUser			= parmUpdateUser,
					NATN_UpdateUserIP1		= NULLIF(CONV(parmUpdateUserIP1,2,10),0),
					NATN_UpdateUserIP2		= CONV(parmUpdateUserIP2,2,10),
					NATN_UpdateTimestamp	= UTC_TIMESTAMP()
				WHERE NATN_ID				= parmID;
				SELECT parmID;
			END;
		END IF;
	END;