/*////////////////////////////////////////////////////////////////

Delete Privilege_Groups row

Author: 	Bob Carver
Created:	24 Jun 2010

////////////////////////////////////////////////////////////////*/

DROP PROCEDURE IF EXISTS PRVG_Delete;

CREATE PROCEDURE PRVG_Delete
	(
		IN  parmID				smallint	UNSIGNED,
		IN  parmUSROID			mediumint	UNSIGNED,
		IN  parmUpdateUserIP1	varchar(64),
		IN  parmUpdateUserIP2	varchar(64)
	)
	BEGIN
		DECLARE functionCount	int;
		DECLARE oldTokenName	varchar(50);

		# Are there any subordinate Privilege Names?
		SELECT COUNT(*) INTO functionCount FROM Privilege_Names  WHERE PRVN_PRVG_ID = parmID;
		IF functionCount > 0 THEN
			# Yes, return false
			BEGIN
				SELECT 1 AS ReturnCode, 'Privilege_Names' AS MoreInfo;
			END;
		ELSE
			# No, we're good to go
			BEGIN
				IF EXISTS (SELECT PRVG_ID FROM Privilege_Groups WHERE PRVG_ID = parmID) THEN
					BEGIN
						START TRANSACTION;
						SELECT PRVG_Token INTO oldTokenName FROM Privilege_Groups WHERE PRVG_ID = parmId;
						DELETE FROM Privilege_Groups WHERE PRVG_ID = parmID;
						CALL AUDT_Insert (2, (SELECT USRM_Name FROM Users_Operators INNER JOIN Users_Main ON USRM_ID = USRO_USRM_ID = USRM_ID WHERE USRO_ID = parmUSROID), parmUpdateUserIP1, parmUpdateUserIP2, parmID, 'PRVG', NULL, NULL, oldTokenName);
						COMMIT;
					END;
				END IF;
				SELECT 0 AS ReturnCode, '' AS MoreInfo;
			END;
		END IF;
	END;
