/*////////////////////////////////////////////////////////////////

INSERT/UPDATE Privilege_Groups Table

Author: 	Bob Carver
Created:	23 Feb 2010

Controls:
1. If parmId is negative, then INSERT is done; else UPDATE

////////////////////////////////////////////////////////////////*/

DROP PROCEDURE IF EXISTS PRVG_Update;

CREATE PROCEDURE PRVG_Update
(
    IN parmID				smallint	UNSIGNED,
    IN parmToken			varchar(50),
    IN parmSequence			smallint	UNSIGNED,
    IN parmDescription		varchar(150),
    IN parmUpdateUser		varchar(25),
    IN parmUpdateUserIP1	varchar(64),
    IN parmUpdateUserIP2	varchar(64)
)
	BEGIN
		IF parmID = 0 THEN
		# insert new group
			DoInsert: BEGIN
				INSERT INTO Privilege_Groups
				(
					PRVG_Token,
					PRVG_Sequence,
					PRVG_Description,
					PRVG_UpdateUser,
					PRVG_UpdateUserIP1,
					PRVG_UpdateUserIP2,
					PRVG_UpdateTimestamp
				)
				VALUES
				(
					parmToken,
					parmSequence,
					parmDescription,
					parmUpdateUser,
					NULLIF(CONV(parmUpdateUserIP1,2,10),0),
					CONV(parmUpdateUserIP2,2,10),
					UTC_TIMESTAMP()
				);
				SELECT LAST_INSERT_ID();
			END DoInsert;
		ELSE
		# update existing group
			DoUpdate: BEGIN
				UPDATE Privilege_Groups SET
					PRVG_Token			= parmToken,
					PRVG_Sequence		= parmSequence,
					PRVG_Description	= parmDescription,
					PRVG_UpdateUser		= parmUpdateUser,
					PRVG_UpdateUserIP1	= NULLIF(CONV(parmUpdateUserIP1,2,10),0),
					PRVG_UpdateUserIP2	= CONV(parmUpdateUserIP2,2,10),
					PRVG_UpdateTimestamp= UTC_TIMESTAMP()
				WHERE PRVG_ID			= parmID;
				SELECT parmID;
			END DoUpdate;
		END IF;
	END;
