/*////////////////////////////////////////////////////////////////

INSERT/UPDATE Privilege Names Table

Author: 	Bob Carver
Created:	23 Feb 2010

Controls:
1. If parmId is negative, then INSERT is done; else UPDATE

////////////////////////////////////////////////////////////////*/

DROP PROCEDURE IF EXISTS PRVN_Update;

CREATE PROCEDURE PRVN_Update
(
    IN parmID				smallint	UNSIGNED,
    IN parmPRVGID			tinyint		UNSIGNED,
    IN parmToken			varchar(50),
    IN parmSequence			smallint	UNSIGNED,
    IN parmProgram			varchar(100),
	IN parmSuperUserOnly	boolean,
    IN parmIncludeInMenu	boolean,
    IN parmPseudo			boolean,
    IN parmAdd				boolean,
    IN parmEdit				boolean,
    IN parmPrint			boolean,
    IN parmPrintList		boolean,
    IN parmExport			boolean,
    IN parmInactivate		boolean,
    IN parmDelete			boolean,
    IN parmNotes			boolean,
    IN parmItemsPerPage		smallint	UNSIGNED,
    IN parmDropDownLimit	smallint	UNSIGNED,
    IN parmUpdateUser		varchar(25),
    IN parmUpdateUserIP1	varchar(64),
    IN parmUpdateUserIP2	varchar(64)
)
	BEGIN
		IF parmID = 0 THEN
		# insert new function name
			DoInsert: BEGIN
				INSERT INTO Privilege_Names
				(
					PRVN_PRVG_ID,
					PRVN_Token,
					PRVN_Sequence,
					PRVN_Program,
					PRVN_SuperUserOnly,
					PRVN_IncludeInMenu,
					PRVN_Pseudo,
					PRVN_Add,
					PRVN_Edit,
					PRVN_Print,
					PRVN_PrintList,
					PRVN_Export,
					PRVN_Inactivate,
					PRVN_Delete,
					PRVN_Notes,
					PRVN_ItemsPerPage,
					PRVN_DropDownLimit,
					PRVN_UpdateUser,
					PRVN_UpdateUserIP1,
					PRVN_UpdateUserIP2,
					PRVN_UpdateTimestamp
				)
				VALUES
				(
    				parmPRVGID,
					parmToken,
					parmSequence,
					parmProgram,
					parmSuperUserOnly,
					parmIncludeInMenu,
					parmPseudo,
					parmAdd,
					parmEdit,
					parmPrint,
					parmPrintList,
					parmExport,
					parmInactivate,
					parmDelete,
					parmNotes,
					parmItemsPerPage,
					parmDropDownLimit,
					parmUpdateUser,
					NULLIF(CONV(parmUpdateUserIP1,2,10),0),
					CONV(parmUpdateUserIP2,2,10),
					UTC_TIMESTAMP()
				);
				SELECT LAST_INSERT_ID();
			END DoInsert;
		ELSE
		# update existing function name
			DoUpdate: BEGIN
				UPDATE Privilege_Names SET
					PRVN_PRVG_ID		= parmPRVGID,
					PRVN_Token			= parmToken,
					PRVN_Sequence		= parmSequence,
					PRVN_Program		= parmProgram,
					PRVN_SuperUserOnly	= parmSuperUserOnly,
					PRVN_IncludeInMenu	= parmIncludeInMenu,
					PRVN_Pseudo			= parmPseudo,
					PRVN_Add			= parmAdd,
					PRVN_Edit			= parmEdit,
					PRVN_Print			= parmPrint,
					PRVN_PrintList		= parmPrintList,
					PRVN_Export			= parmExport,
					PRVN_Inactivate		= parmInactivate,
					PRVN_Delete			= parmDelete,
					PRVN_Notes			= parmNotes,
					PRVN_ItemsPerPage	= parmItemsPerPage,
					PRVN_DropDownLimit	= parmDropDownLimit,
					PRVN_UpdateUser		= parmUpdateUser,
					PRVN_UpdateUserIP1	= NULLIF(CONV(parmUpdateUserIP1,2,10),0),
					PRVN_UpdateUserIP2	= CONV(parmUpdateUserIP2,2,10),
					PRVN_UpdateTimestamp= UTC_TIMESTAMP()
				WHERE PRVN_ID			= parmID;
				SELECT parmID;
			END DoUpdate;
		END IF;
	END;
