/*////////////////////////////////////////////////////////////////

Select a random system_sound

Author: 	Bob Carver
Created:	20 Feb 2010

Controls:
1. If parmId is negative, then INSERT is done; else UPDATE

////////////////////////////////////////////////////////////////*/

DROP PROCEDURE IF EXISTS SNDS_GetRandomSound;

CREATE PROCEDURE SNDS_GetRandomSound (parmType char(1))
BEGIN

    DECLARE	soundCount int;
    
    # how many do we have in all?
    SELECT COUNT(*) FROM System_Sounds WHERE SNDS_Type = parmType INTO soundCount;
    
    # choose a random offset
    SET @soundOffset = FLOOR(RAND() * (soundCount-1));
    
    # prep a SQL statement
    SET @pType 	= parmType;
    PREPARE STMT FROM 'SELECT SNDS_Name FROM System_Sounds WHERE SNDS_Type = ? LIMIT ?, 1';
    
    # and execute it
    EXECUTE STMT USING @pType, @soundOffset;

END;
