/*////////////////////////////////////////////////////////////////

INSERT/UPDATE System_Sounds Table

Author: 	Bob Carver
Created:	20 Feb 2010

Controls:
1. If parmId is negative, then INSERT is done; else UPDATE

////////////////////////////////////////////////////////////////*/

DROP PROCEDURE IF EXISTS SNDS_Update;

CREATE PROCEDURE SNDS_Update
(
    IN parmID				smallint	UNSIGNED,
    IN parmType				char(1),
    IN parmName				varchar(100),
    IN parmDesc				varchar(1000),
    IN parmUpdateUser		varchar(25),
    IN parmUpdateUserIP1	varchar(64),
    IN parmUpdateUserIP2	varchar(64)
)
	BEGIN
		IF parmID = 0 THEN
		# insert new sound
			DoInsert: BEGIN
				INSERT INTO System_Sounds
				(
					SNDS_Type,
					SNDS_Name,
					SNDS_Description,
					SNDS_UpdateUser,
					SNDS_UpdateUserIP1,
					SNDS_UpdateUserIP2,
					SNDS_UpdateTimestamp
				)
				VALUES
				(
					parmType,
					parmName,
					parmDesc,
					parmUpdateUser,
					NULLIF(CONV(parmUpdateUserIP1,2,10),0),
					CONV(parmUpdateUserIP2,2,10),
					UTC_TIMESTAMP()
				);
				SELECT LAST_INSERT_ID();
			END DoInsert;
		ELSE
		# update existing sound
			DoUpdate: BEGIN
				UPDATE System_Sounds SET
					SNDS_Type			= parmType,
					SNDS_Name			= parmName,
					SNDS_Description	= parmDesc,
					SNDS_UpdateUser		= parmUpdateUser,
					SNDS_UpdateUserIP1	= NULLIF(CONV(parmUpdateUserIP1,2,10),0),
					SNDS_UpdateUserIP2	= CONV(parmUpdateUserIP2,2,10),
					SNDS_UpdateTimestamp= UTC_TIMESTAMP()
				WHERE SNDS_ID			= parmID;
				SELECT parmID;
			END DoUpdate;
		END IF;
	END;
