
DROP PROCEDURE IF EXISTS STAT_Update;

CREATE PROCEDURE STAT_Update
	(
		IN parmID				mediumint	UNSIGNED,
		IN parmNATNID			smallint	UNSIGNED,
		IN parmCode				varchar(5),
		IN parmNameToken		varchar(50),
		IN parmUpdateUser		varchar(25),
		IN parmUpdateUserIP1	varchar(64),
		IN parmUpdateUserIP2	varchar(64)
	)
	BEGIN
       IF parmID = 0 THEN
       # insert new state
           BEGIN
               INSERT INTO States
               (
                   STAT_NATN_ID,
                   STAT_Code,
                   STAT_NameToken,
                   STAT_UpdateUser,
                   STAT_UpdateUserIP1,
                   STAT_UpdateUserIP2,
				   STAT_UpdateTimestamp
               )
               VALUES
               (
                   parmNATNID,
                   parmCode,
                   parmNameToken,
                   parmUpdateUser,
                   NULLIF(CONV(parmUpdateUserIP1,2,10),0),
                   CONV(parmUpdateUserIP2,2,10),
				   UTC_TIMESTAMP()
               );
               SELECT LAST_INSERT_ID();
           END;
       ELSE
       # update existing state
           BEGIN
               UPDATE States SET
                   STAT_NATN_ID			= parmNATNID,
                   STAT_Code			= parmCode,
                   STAT_NameToken       = parmNameToken,
                   STAT_UpdateUser      = parmUpdateUser,
                   STAT_UpdateUserIP1	= NULLIF(CONV(parmUpdateUserIP1,2,10),0),
                   STAT_UpdateUserIP2	= CONV(parmUpdateUserIP2,2,10),
				   STAT_UpdateTimestamp = UTC_TIMESTAMP()
               WHERE STAT_ID			= parmID;
               SELECT parmID;
           END;
       END IF;
   END;