/*////////////////////////////////////////////////////////////////

INSERT/UPDATE System_Collections Table

Author: 	Bob Carver
Created:	03 Feb 2010

Controls:
1. If parmId is negative, then INSERT is done; else UPDATE

////////////////////////////////////////////////////////////////*/

DROP PROCEDURE IF EXISTS SYSC_Update;

CREATE PROCEDURE SYSC_Update
	(
		IN parmID				tinyint		UNSIGNED,
		IN parmSeq				smallint	UNSIGNED,
		IN parmName				varchar(25),
		IN parmDesc				varchar(250),
		IN parmUpdateUser		varchar(25),
		IN parmUpdateUserIP1	varchar(64),
		IN parmUpdateUserIP2	varchar(64)
	)
	BEGIN
		IF parmID = 0 THEN
		# insert new collection
			DoInsert: BEGIN
				INSERT INTO System_Collections
				(
  				SYSC_Sequence,
					SYSC_Name,
					SYSC_Description,
					SYSC_UpdateUser,
					SYSC_UpdateUserIP1,
					SYSC_UpdateUserIP2,
					SYSC_UpdateTimestamp
				)
				VALUES
				(
					parmSeq,
					parmName,
					parmDesc,
					parmUpdateUser,
					NULLIF(CONV(parmUpdateUserIP1,2,10),0),
					CONV(parmUpdateUserIP2,2,10),
					UTC_TIMESTAMP()
				);
				SELECT LAST_INSERT_ID();
			END DoInsert;
		ELSE
		# update existing collection
			DoUpdate: BEGIN
				UPDATE System_Collections SET
  				SYSC_Sequence		= parmSeq,
					SYSC_Name			= parmName,
					SYSC_Description	= parmDesc,
					SYSC_UpdateUser		= parmUpdateUser,
					SYSC_UpdateUserIP1	= NULLIF(CONV(parmUpdateUserIP1,2,10),0),
					SYSC_UpdateUserIP2	= CONV(parmUpdateUserIP2,2,10),
					SYSC_UpdateTimestamp= UTC_TIMESTAMP()
				WHERE SYSC_ID			= parmID;
				SELECT parmID;
			END DoUpdate;
		END IF;
	END;
