/*////////////////////////////////////////////////////////////////

INSERT/UPDATE System_Tokens Table

Author: 	Bob Carver
Created:	03 Feb 2010

Controls:
1. If parmId is negative, then INSERT is done; else UPDATE

////////////////////////////////////////////////////////////////*/

DROP PROCEDURE IF EXISTS SYST_Update;

CREATE PROCEDURE SYST_Update
	(
		IN parmID				smallint	UNSIGNED,
		IN parmSYSCID			tinyint		UNSIGNED,
		IN parmHidden			boolean,
		IN parmSeq				smallint	UNSIGNED,
		IN parmToken			varchar(50),
		IN parmType				char(1),
		IN parmNotes			varchar(250),
		IN parmUpdateUser		varchar(25),
		IN parmUpdateUserIP1	varchar(64),
		IN parmUpdateUserIP2	varchar(64)
	)
	BEGIN
		IF parmID = 0 THEN
		# insert new token
			DoInsert: BEGIN
				INSERT INTO System_Tokens
				(
  				SYST_SYSC_ID,
					SYST_IsMasterOnly,
					SYST_Sequence,
					SYST_Token,
					SYST_Type,
					SYST_Notes,
					SYST_UpdateUser,
					SYST_UpdateUserIP1,
					SYST_UpdateUserIP2,
					SYST_UpdateTimestamp
				)
				VALUES
				(
					parmSYSCID,
					parmHidden,
					parmSeq,
					parmToken,
					parmType,
					parmNotes,
					parmUpdateUser,
					NULLIF(CONV(parmUpdateUserIP1,2,10),0),
					CONV(parmUpdateUserIP2,2,10),
					UTC_TIMESTAMP()
				);
				SELECT LAST_INSERT_ID();
			END DoInsert;
		ELSE
		# update existing token
			DoUpdate: BEGIN
				UPDATE System_Tokens SET
  				SYST_SYSC_ID		= parmSYSCID,
					SYST_IsMasterOnly	= parmHidden,
					SYST_Sequence		= parmSeq,
					SYST_Token			= parmToken,
					SYST_Type			= parmType,
					SYST_Notes			= parmNotes,
					SYST_UpdateUser		= parmUpdateUser,
					SYST_UpdateUserIP1	= NULLIF(CONV(parmUpdateUserIP1,2,10),0),
					SYST_UpdateUserIP2	= CONV(parmUpdateUserIP2,2,10),
					SYST_UpdateTimestamp= UTC_TIMESTAMP()
				WHERE SYST_ID			= parmID;
				SELECT parmID;
			END DoUpdate;
		END IF;
	END;
