/*////////////////////////////////////////////////////////////////

INSERT/UPDATE System_Values Table

Author: 	Bob Carver
Created:	05 Feb 2010

Controls:
1. If parmId is negative, then INSERT is done; else UPDATE

////////////////////////////////////////////////////////////////*/

DROP PROCEDURE IF EXISTS SYSV_Update;

CREATE PROCEDURE SYSV_Update
	(
		IN parmID				smallint	UNSIGNED,
		IN parmOPRSID			mediumint	UNSIGNED,		/* unused on Update */
		IN parmSYSTID			smallint	UNSIGNED,		/* unused on Update */
		IN parmValue			varchar(250),
		IN parmUpdateUser		varchar(25),
		IN parmUpdateUserIP1	varchar(64),
		IN parmUpdateUserIP2	varchar(64)
	)
	BEGIN
		IF parmID = 0 THEN
		# insert new value
			DoInsert: BEGIN
				DECLARE tempID mediumint;
				IF ISNULL(parmOPRSID) THEN
					SELECT SYSS_ID FROM System_Settings WHERE SYSS_OPRS_ID IS NULL INTO tempID;
				ELSE
					SELECT SYSS_ID FROM System_Settings WHERE SYSS_OPRS_ID = parmOPRSID INTO tempID;
				END IF;
				INSERT INTO System_Values
				(
  				SYSV_SYSS_ID,
					SYSV_SYST_ID,
					SYSV_Value,
					SYSV_UpdateUser,
					SYSV_UpdateUserIP1,
					SYSV_UpdateUserIP2,
					SYSV_UpdateTimestamp
				)
				VALUES
				(
					tempID,
					parmSYSTID,
					parmValue,
					parmUpdateUser,
					NULLIF(CONV(parmUpdateUserIP1,2,10),0),
					CONV(parmUpdateUserIP2,2,10),
					UTC_TIMESTAMP()
				);
				SELECT LAST_INSERT_ID();
			END DoInsert;
		ELSE
		# update existing value
			DoUpdate: BEGIN
				UPDATE System_Values SET
  				SYSV_VALUE			= parmValue,
					SYSV_UpdateUser		= parmUpdateUser,
					SYSV_UpdateUserIP1	= NULLIF(CONV(parmUpdateUserIP1,2,10),0),
					SYSV_UpdateUserIP2	= CONV(parmUpdateUserIP2,2,10),
					SYSV_UpdateTimestamp= UTC_TIMESTAMP()
				WHERE SYSV_ID			= parmID;
				SELECT parmID;
			END DoUpdate;
		END IF;
	END;