/*////////////////////////////////////////////////////////////////

INSERT/UPDATE System Table

Author: 	Bob Carver
Created:	19 Jun 2010

Controls:
1. If parmId is negative, then INSERT is done; else UPDATE

////////////////////////////////////////////////////////////////*/

DROP PROCEDURE IF EXISTS TBLS_Update;

CREATE PROCEDURE TBLS_Update
(
    IN parmID				smallint	UNSIGNED,
    IN parmCode				char(4),
    IN parmTableName		varchar(50),
    IN parmDescription		varchar(2000),
    IN parmUpdateUser		varchar(25),
    IN parmUpdateUserIP1	varchar(64),
    IN parmUpdateUserIP2	varchar(64)
)
	BEGIN
		IF parmID = 0 THEN
		# insert new system table
			DoInsert: BEGIN
				INSERT INTO System_Tables
				(
					TBLS_Code,
					TBLS_TableName,
					TBLS_Description,
					TBLS_UpdateUser,
					TBLS_UpdateUserIP1,
					TBLS_UpdateUserIP2,
					TBLS_UpdateTimestamp
				)
				VALUES
				(
					UPPER(parmCode),
					parmTableName,
					parmDescription,
					parmUpdateUser,
					NULLIF(CONV(parmUpdateUserIP1,2,10),0),
					CONV(parmUpdateUserIP2,2,10),
					UTC_TIMESTAMP()
				);
				SELECT LAST_INSERT_ID();
			END DoInsert;
		ELSE
		# update existing system table
			DoUpdate: BEGIN
				UPDATE System_Tables SET
					TBLS_Code			= UPPER(parmCode),
					TBLS_TableName		= parmTableName,
					TBLS_Description	= parmDescription,
					TBLS_UpdateUser		= parmUpdateUser,
					TBLS_UpdateUserIP1	= NULLIF(CONV(parmUpdateUserIP1,2,10),0),
					TBLS_UpdateUserIP2	= CONV(parmUpdateUserIP2,2,10),
					TBLS_UpdateTimestamp= UTC_TIMESTAMP()
				WHERE TBLS_ID			= parmID;
				SELECT parmID;
			END DoUpdate;
		END IF;
	END;
