
DROP PROCEDURE IF EXISTS USRM_Update;

CREATE PROCEDURE USRM_Update
(
    IN parmID				mediumint	UNSIGNED,
    IN parmOPRSID			mediumint	UNSIGNED,
    IN parmUsername			varchar(25),
	IN parmEmail1			varchar(100),
	IN parmEmail2			varchar(100),
	IN parmTimeZone			varchar(30),
	IN parmNameFirst		varchar(35),
	IN parmNameMiddle		varchar(25),
	IN parmNameLast			varchar(35),
	IN parmNameSuffix		varchar(15),
	IN parmNickName			varchar(25),
	IN parmGender			char(1),
    IN parmUpdateUser		varchar(25),
    IN parmUpdateUserIP1	varchar(64),
    IN parmUpdateUserIP2	varchar(64)
)
BEGIN

    DECLARE userkey int UNSIGNED;

    IF parmID = 0 THEN

        -- insert new user

        BEGIN

        	-- first insert the User instance

            INSERT INTO Users_Main
            (
            	USRM_Name,
				USRM_EmailPrimary,
				USRM_EmailAlternate,
				USRM_TimeZone,
				USRM_NameFirst,
				USRM_NameMiddle,
				USRM_NameLast,
				USRM_NameSuffix,
				USRM_NickName,
				USRM_Gender,
            	USRM_UpdateUser,
            	USRM_UpdateUserIP1,
            	USRM_UpdateUserIP2,
				USRM_UpdateTimestamp
            )
            VALUES
            (
            	parmUsername,
				parmEmail1,
				parmEmail2,
				parmTimeZone,
				parmNameFirst,
				parmNameMiddle,
				parmNameLast,
				parmNameSuffix,
				parmNickName,
				parmGender,
            	parmUpdateUser,
            	NULLIF(CONV(parmUpdateUserIP1,2,10),0),
            	CONV(parmUpdateUserIP2,2,10),
				UTC_TIMESTAMP()
            );
            SELECT LAST_INSERT_ID() INTO userkey;

            -- now insert a link to the Operators table

            INSERT INTO Users_Operators (USRO_USRM_ID, USRO_OPRS_ID) VALUES (userkey, parmOPRSID);

		END;

	ELSE

		-- update existing user

		BEGIN

			-- first update the User instance

			UPDATE Users_Main INNER JOIN Users_Operators ON USRO_USRM_ID = USRM_ID AND USRO_OPRS_ID = parmOPRSID
            SET	USRM_Name			= parmUsername,
				USRM_EmailPrimary	= parmEmail1,
				USRM_EmailAlternate	= parmEmail2,
				USRM_TimeZone		= parmTimeZone,
				USRM_NameFirst		= parmNameFirst,
				USRM_NameMiddle		= parmNameMiddle,
				USRM_NameLast		= parmNameLast,
				USRM_NameSuffix		= parmNameSuffix,
				USRM_NickName		= parmNickName,
				USRM_Gender			= parmGender,
           	 	USRM_UpdateUser		= parmUpdateUser,
            	USRM_UpdateUserIP1	= NULLIF(CONV(parmUpdateUserIP1,2,10),0),
            	USRM_UpdateUserIP2	= CONV(parmUpdateUserIP2,2,10),
				USRM_UpdateTimestamp= UTC_TIMESTAMP()
            WHERE USRM_ID			= parmID;
            SET userkey = parmID;

		END;

	END IF;

	SELECT userkey;

END;