/*////////////////////////////////////////////////////////////////

INSERT New User Password

Author: 	Bob Carver
Created:	09 Feb 2010
Modified:	16 Feb 2010
			reset password required attribute in Users_Main table

////////////////////////////////////////////////////////////////*/

DROP PROCEDURE IF EXISTS USRP_AddPassword;

CREATE PROCEDURE USRP_AddPassword
(
    IN 	parmUSRMID			mediumint	UNSIGNED,
    IN 	parmNewPassword		char(32),
	IN  parmNewPassRequired	boolean,
    IN 	parmSavedPasswords	int
)

BEGIN

	DECLARE matchCount int;

	# ensure new password does not match any we have
	SELECT COUNT(*) FROM Users_Passwords WHERE USRP_USRM_ID = parmUSRMID AND UPPER(USRP_Password) = UPPER(parmNewPassword) INTO matchCount;

	# no matches, so we can add the new one
	IF matchCount = 0 THEN
		BEGIN
        	# resequence current passwords
        	UPDATE Users_Passwords SET USRP_SeqNo = USRP_SeqNo + 1 WHERE USRP_USRM_ID = parmUSRMID ORDER BY USRP_SeqNo DESC;

        	# insert the new one
        	INSERT INTO Users_Passwords (USRP_USRM_ID, USRP_SeqNo, USRP_Password) VALUES (parmUSRMID, 1, parmNewPassword);

        	# truncate any we don't want to save
    		DELETE FROM Users_Passwords WHERE USRP_USRM_ID = parmUSRMID AND USRP_SeqNo > parmSavedPasswords;

			# set password now required attribute
			UPDATE Users_Main SET USRM_NewPasswordNeeded = parmNewPassRequired WHERE USRM_ID = parmUSRMID;

			# tell my master that all went OK
			SELECT 0;
		END;
	ELSE
		BEGIN
			# tell my master that we found a duplicate
			SELECT -1;
		END;
	END IF;

END;
