CREATE TABLE Airports_Operators
(
	ARPO_ID							mediumint UNSIGNED	NOT NULL AUTO_INCREMENT PRIMARY KEY,
	ARPO_ARPT_ID					smallint UNSIGNED	NOT NULL COMMENT 'Vector to ARPT_ID',
	ARPO_OPRS_ID					mediumint UNSIGNED	NOT NULL COMMENT 'Vector to OPRS_ID',
	ARPO_IsEmployeeBase				boolean			NOT NULL DEFAULT 0 COMMENT 'If True, airport is an employee base',
	ARPO_InclementWeather			boolean			NOT NULL DEFAULT 0 COMMENT 'If True, airport inclement weather procedures active',
	ARPO_ExcludeFromQuotes			boolean			NOT NULL DEFAULT 0  COMMENT 'True to exclude from quotes',
	ARPO_ExclusionReason			varchar(200)		NOT NULL DEFAULT '' COMMENT 'Optional reason for excluding airport from quotes',
	ARPO_DefaultGroundTime			smallint UNSIGNED	NULL COMMENT 'Default # minutes to assume for ground time',
	ARPO_DefaultGroundTimePat		smallint UNSIGNED	NULL COMMENT 'Default # minutes to assume for ground time w/ patient',
	ARPO_DefaultOriginationFee		smallint UNSIGNED	NULL COMMENT 'Default origination fee when starting from this airport',
	ARPO_DefaultHotelRate			smallint UNSIGNED	NULL,
	ARPO_DefaultGroundXprtRate		smallint UNSIGNED	NULL,
	ARPO_DefaultMedSuppliesCharge	smallint UNSIGNED	NULL,
	ARPO_DefaultIntlLandingFee		smallint UNSIGNED	NULL COMMENT 'Default landing fee for this airport',
	ARPO_USIntlLandingFee			boolean 			NOT NULL DEFAULT 0 COMMENT 'If True, international landing fee applies to this (if US airport)',
	ARPO_UpdateUser					varchar(25)		NOT NULL,
	ARPO_UpdateUserIP1				bigint UNSIGNED		NULL,
	ARPO_UpdateUserIP2				bigint UNSIGNED		NOT NULL,
	ARPO_UpdateTimestamp			timestamp			NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
    FOREIGN KEY fk_ARPO_to_ARPT (ARPO_ARPT_ID) 	REFERENCES Airports	(ARPT_ID) ON DELETE CASCADE,
    FOREIGN KEY fk_ARPO_to_OPRS (ARPO_OPRS_ID) 	REFERENCES Operators	(OPRS_ID) ON DELETE CASCADE
)
ENGINE=InnoDB DEFAULT CHARACTER SET utf8 COLLATE utf8_bin COMMENT='Airport Operator Data'