CREATE TABLE Airports
(
	ARPT_ID					smallint UNSIGNED	NOT NULL AUTO_INCREMENT PRIMARY KEY,
	ARPT_ICAO				char(4) 			NOT NULL COMMENT 'International Civil Aviation Organization airport code',
	ARPT_IATA				char(3) 			NULL COMMENT 'International Air Transport Association airport code',
	ARPT_City				varchar(50) 		NULL COMMENT 'City in which airport is located or most proximate',
	ARPT_ShortName			varchar(20) 		NULL,
	ARPT_Name				varchar(50) 		NULL,
	ARPT_StateID			mediumint UNSIGNED 	NULL COMMENT 'Vector to STAT_ID if US or CA airport',
	ARPT_CountryID			smallint UNSIGNED 	NOT NULL COMMENT 'Vector to NATN_ID',
	ARPT_RunwayID			varchar(8) 		NULL COMMENT 'Longest runway identifer',
	ARPT_RunwayLength		smallint UNSIGNED	NULL COMMENT 'Longest runwway length',
	ARPT_RunwayWidth		tinyint UNSIGNED	NULL COMMENT 'Longest runway width',
	ARPT_TimeZone			varchar(30)		NULL COMMENT 'Airort''s timezone designation',
	ARPT_Latitude			varchar(9) 		NULL,
	ARPT_Longitude			varchar(9) 		NULL,
	ARPT_Elevation			varchar(5) 		NULL,
	ARPT_UpdateUser			varchar(25)		NOT NULL,
	ARPT_UpdateUserIP1		bigint UNSIGNED		NULL,
	ARPT_UpdateUserIP2		bigint UNSIGNED		NOT NULL,
	ARPT_UpdateTimestamp	timestamp			NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
    FOREIGN KEY fk_ARPT_to_NATN (ARPT_CountryID) 	REFERENCES Countries_Main	(NATN_ID) ON DELETE RESTRICT,
    FOREIGN KEY fk_ARPT_to_STA2 (ARPT_StateID) 	REFERENCES States			(STAT_ID) ON DELETE RESTRICT
)
ENGINE=InnoDB DEFAULT CHARACTER SET utf8 COLLATE utf8_bin COMMENT='Airports'