CREATE TABLE Audit_Log
(
AUDT_ID 				int UNSIGNED 		NOT NULL 	AUTO_INCREMENT PRIMARY KEY,
  AUDT_Type				smallint UNSIGNED	NOT NULL 								COMMENT 'Audit entry type',
  AUDT_Timestamp 		timestamp 			NOT NULL	DEFAULT CURRENT_TIMESTAMP	COMMENT 'Time that user inserted or altered the parent record',
  AUDT_Username			varchar(25) 		NOT NULL 								COMMENT 'User name of user who initiated the change',
  AUDT_UserIP1			bigint UNSIGNED		NULL 									COMMENT 'User''s IP address (part 1) in integer form',
  AUDT_UserIP2			bigint UNSIGNED		NOT NULL 								COMMENT 'User''s IP address (part 2) in integer form',
  AUDT_ParentID 		int UNSIGNED		NOT NULL 								COMMENT 'Vector to appropriate parent table',
  AUDT_ParentCode 		char(4) 			NOT NULL								COMMENT 'Table code for parent table',
  AUDT_SubordinateID 	int UNSIGNED		NULL 									COMMENT 'Optional vector to second table, subordinate to parent table',
  AUDT_SubordinateCode 	char(4) 			NULL 									COMMENT 'Optional table code for second table, subordinate to parent table',
  AUDT_Details 			varchar(500)		NULL 									COMMENT 'Optional addditional information relative to the change'
)
ENGINE=MyISAM DEFAULT CHARACTER SET utf8 COLLATE utf8_bin COMMENT='System audit log: who, when, what'