CREATE TABLE Language_Tokens
(
  LNGT_ID 				smallint UNSIGNED	NOT NULL AUTO_INCREMENT PRIMARY KEY,
  LNGT_LNGC_ID 			smallint UNSIGNED	NOT NULL COMMENT 'Vector to Language Collection',
  LNGT_Token			varchar(50) 		NOT NULL COMMENT 'Language Token (internal variable) name',
  LNGT_Sequence			smallint UNSIGNED	NOT NULL DEFAULT '0' COMMENT 'Language Token sequence override',
  LNGT_Notes		 	varchar(250) 		NOT NULL DEFAULT '' COMMENT 'Optional internal notes',
  LNGT_UpdateUser		varchar(25)			NOT NULL,
  LNGT_UpdateUserIP1	bigint UNSIGNED		NULL,
  LNGT_UpdateUserIP2	bigint UNSIGNED		NOT NULL,
  LNGT_UpdateTimestamp	timestamp			NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,

  UNIQUE  KEY uk_LNGT_Token (LNGT_Token),
  FOREIGN KEY fk_LNGT_to_LNGC (LNGT_LNGC_ID) REFERENCES Language_Collections (LNGC_ID) ON DELETE CASCADE
)
ENGINE=InnoDB DEFAULT CHARACTER SET utf8 COLLATE utf8_bin COMMENT='Language Tokens'
