CREATE TABLE Language_Values
(
    LNGV_ID 				mediumint UNSIGNED	NOT NULL AUTO_INCREMENT PRIMARY KEY,
    LNGV_LNGS_ID 			smallint UNSIGNED	NOT NULL COMMENT 'Vector to Language Set',
    LNGV_LNGT_ID 			smallint UNSIGNED	NOT NULL COMMENT 'Vector to Language Tokens',
    LNGV_Text 				varchar(250) 		NOT NULL COMMENT 'What a Language Token maps to',
    LNGV_Tooltip 			text		 		NOT NULL COMMENT 'Optional tooltip text',
    LNGV_UpdateUser			varchar(25)			NOT NULL,
    LNGV_UpdateUserIP1		bigint UNSIGNED		NULL,
    LNGV_UpdateUserIP2		bigint UNSIGNED		NOT NULL,
    LNGV_UpdateTimestamp	timestamp			NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,

    FOREIGN KEY fk_LNGV_to_LNGT (LNGV_LNGT_ID) REFERENCES Language_Tokens (LNGT_ID) ON DELETE CASCADE,
	FOREIGN KEY fk_LNGV_to_LNGS (LNGV_LNGS_ID) REFERENCES Language_Sets (LNGS_ID) ON DELETE CASCADE
)
ENGINE=InnoDB DEFAULT CHARACTER SET utf8 COLLATE utf8_bin COMMENT='Language Values'