CREATE TABLE Countries_Main
(
	NATN_ID 					smallint UNSIGNED	NOT NULL AUTO_INCREMENT  PRIMARY KEY,
	NATN_Code					char(2) 			NOT NULL COMMENT '2-character ISO code',
	NATN_Code_ISO3 				char(3) 			NOT NULL DEFAULT '' COMMENT '3-character ISO code',
	NATN_Code_FIPS				char(2) 			NOT NULL DEFAULT '' COMMENT '2-character FIPS code',
	NATN_PseudoParent			smallint UNSIGNED	NULL COMMENT 'If not NULL, country is a ''pseudo-country'', and this is the vector to the parent Country',
	NATN_StateCodeLength 		tinyint UNSIGNED 	NOT NULL DEFAULT 0 COMMENT 'Length of STAT_Code value, if applicable; Zero if no STAT_Code applies',
	NATN_NameToken				varchar(50)		NOT NULL COMMENT 'Language token for Country name',
	NATN_StateToken				varchar(50)		NOT NULL DEFAULT '' COMMENT 'Language token for how state/province/whatever is referred to in the Country; Empty if no state/province applies',
	NATN_ZIPToken				varchar(50)		NOT NULL DEFAULT '' COMMENT 'Language token for how zip/postal code is referred to in the Country; Empty if no zip/postal code applies',
	NATN_UpdateUser				varchar(25)		NOT NULL,
	NATN_UpdateUserIP1			bigint UNSIGNED		NULL,
	NATN_UpdateUserIP2			bigint UNSIGNED		NOT NULL,
	NATN_UpdateTimestamp		timestamp			NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,

	UNIQUE  KEY uk_NATN_Code	(NATN_Code)
)
ENGINE=InnoDB DEFAULT CHARACTER SET utf8 COLLATE utf8_bin COMMENT='Countries'
