CREATE TABLE Countries_Operators
(
	NATO_ID 					mediumint UNSIGNED	NOT NULL AUTO_INCREMENT PRIMARY KEY,
	NATO_NATN_ID				smallint UNSIGNED	NOT NULL COMMENT 'Vector to Countries_Main',
	NATO_OPRS_ID 				mediumint UNSIGNED 	NULL COMMENT 'Optional vector to Operators; if NULL, system default values',
	NATO_DefaultLandingFee		smallint UNSIGNED	NOT NULL DEFAULT 0  COMMENT 'Default landing fee for the country (USD)',
	NATO_DefaultHotelRate		smallint UNSIGNED	NOT NULL DEFAULT 0  COMMENT 'Default hotel rate for the country (USD)',
	NATO_DefaultGroundXprtRate	smallint UNSIGNED	NOT NULL DEFAULT 0  COMMENT 'Default ground transportation fee for the country (USD)',
	NATO_IncludeEuroControl		boolean			NOT NULL DEFAULT 0  COMMENT 'True if part of Euro control',
	NATO_ExcludeFromQuotes		boolean			NOT NULL DEFAULT 0  COMMENT 'True to exclude from quotes',
	NATO_ExclusionReason		varchar(200)		NOT NULL DEFAULT '' COMMENT 'Optional reason for excluding country from quotes',
	NATO_UpdateUser				varchar(25)		NOT NULL,
	NATO_UpdateUserIP1			bigint UNSIGNED		NULL,
	NATO_UpdateUserIP2			bigint UNSIGNED		NOT NULL,
	NATO_UpdateTimestamp		timestamp			NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,

    FOREIGN KEY fk_NATO_to_NATN (NATO_NATN_ID) REFERENCES Countries_Main	(NATN_ID) ON DELETE CASCADE,
    FOREIGN KEY fk_NATO_to_OPRS (NATO_OPRS_ID) REFERENCES Operators 		(OPRS_ID) ON DELETE CASCADE
)
ENGINE=InnoDB DEFAULT CHARACTER SET utf8 COLLATE utf8_bin COMMENT='Country Operator Data'
