CREATE TABLE Operators
(
	OPRS_ID 					mediumint UNSIGNED	NOT NULL AUTO_INCREMENT PRIMARY KEY,
	OPRS_ParentID 				mediumint UNSIGNED	NULL COMMENT 'If OPRS_IsDivision TRUE, vector to parent Operator''s OPRS_ID',
	OPRS_IsDivision 			boolean 			NOT NULL DEFAULT '0' COMMENT 'True if Operator is subordinate to another Operator, a la ''a Division of''',
	OPRS_IsInactive 			boolean 			NOT NULL DEFAULT '0' COMMENT 'True if Operator is inactive',
	OPRS_LegalName 				varchar(100) 		NOT NULL COMMENT 'Operator''s legal name',
	OPRS_ShortName 				varchar(100) 		NULL COMMENT 'Operator''s short name',
	OPRS_AddressLine1 			varchar(50) 		NULL,
	OPRS_AddressLine2 			varchar(50) 		NULL,
	OPRS_AddressLine3 			varchar(50) 		NULL,
	OPRS_City 					varchar(100) 		NOT NULL,
	OPRS_StateID 				mediumint UNSIGNED 	NULL COMMENT 'Vector to STAT_ID',
	OPRS_Zip 					varchar(10) 		NULL,
	OPRS_CountryID 				smallint UNSIGNED 	NOT NULL COMMENT 'Vector to NATN_ID',
	OPRS_TimeZone				varchar(30)		NULL COMMENT 'Operator''s timezone designation',
	OPRS_ContactNameFirst		varchar(35) 		NULL,
	OPRS_ContactNameMiddle		varchar(25) 		NULL,
	OPRS_ContactNameLast		varchar(35) 		NULL,
	OPRS_ContactNameSuffix		varchar(15) 		NULL,
	OPRS_ContactNickName		varchar(25) 		NULL,
	OPRS_ContactAddressLine1 	varchar(50) 		NULL,
	OPRS_ContactAddressLine2 	varchar(50) 		NULL,
	OPRS_ContactAddressLine3 	varchar(50) 		NULL,
	OPRS_ContactCity 			varchar(100) 		NULL,
	OPRS_ContactStateID 		mediumint UNSIGNED 	NULL,
	OPRS_ContactZip 			varchar(10) 		NULL,
	OPRS_ContactCountryID 		smallint UNSIGNED 	NULL,
	OPRS_ContactTimeZone		varchar(30)		NULL COMMENT 'Contact''s tTimezone designation',
	OPRS_EmailPrimary			varchar(100)		NULL COMMENT 'Contact''s primary email address',
    OPRS_EmailAlternate			varchar(100)		NULL COMMENT 'Contact''s aternate email address',
	OPRS_UpdateUser				varchar(25)		NOT NULL,
	OPRS_UpdateUserIP1			bigint UNSIGNED		NULL,
	OPRS_UpdateUserIP2			bigint UNSIGNED		NOT NULL,
	OPRS_UpdateTimestamp		timestamp			NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,

    FOREIGN KEY fk_OPRS_to_NATN1 (OPRS_CountryID) 			REFERENCES Countries_Main	(NATN_ID) ON DELETE RESTRICT,
    FOREIGN KEY fk_OPRS_to_NATN2 (OPRS_ContactCountryID) 	REFERENCES Countries_Main	(NATN_ID) ON DELETE RESTRICT,
    FOREIGN KEY fk_OPRS_to_STAT1 (OPRS_StateID) 			REFERENCES States		(STAT_ID) ON DELETE RESTRICT,
    FOREIGN KEY fk_OPRS_to_STAT2 (OPRS_ContactStateID) 	REFERENCES States		(STAT_ID) ON DELETE RESTRICT
)
ENGINE=InnoDB DEFAULT CHARACTER SET utf8 COLLATE utf8_bin COMMENT='Air evacuation aircraft operators'
