CREATE TABLE Privilege_Names
(
	PRVN_ID					smallint 	UNSIGNED	NOT NULL AUTO_INCREMENT PRIMARY KEY,
	PRVN_PRVG_ID			tinyint 	UNSIGNED	NOT NULL COMMENT 'Vector to Privilege Group',
 	PRVN_Token				varchar(50) 			NOT NULL COMMENT 'Language Token for Privilege Name',
	PRVN_Sequence			smallint	UNSIGNED	NOT NULL DEFAULT 0 COMMENT 'Privilege Name sequence override',
	PRVN_Program			varchar(100) 			NOT NULL DEFAULT '' COMMENT 'Program to invoke',
	PRVN_IncludeInMenu		boolean				NOT NULL DEFAULT 1 COMMENT 'True to include in navigation menu',
	PRVN_SuperUserOnly		boolean				NOT NULL DEFAULT 0 COMMENT 'True if available only to super user',
	PRVN_Pseudo				boolean				NOT NULL DEFAULT 0 COMMENT 'True if a pseudo-privilege',
	PRVN_Add				boolean				NOT NULL DEFAULT 0 COMMENT 'Add action is pertinent',
	PRVN_Edit				boolean				NOT NULL DEFAULT 0 COMMENT 'Edit action is pertinent',
	PRVN_Print				boolean				NOT NULL DEFAULT 0 COMMENT 'Print action is pertinent',
	PRVN_PrintList			boolean				NOT NULL DEFAULT 0 COMMENT 'Print List action is pertinent',
	PRVN_Export				boolean				NOT NULL DEFAULT 0 COMMENT 'Export action is pertinent',
	PRVN_Inactivate			boolean				NOT NULL DEFAULT 0 COMMENT 'Activate/Inactivate action is pertinent',
	PRVN_Delete				boolean				NOT NULL DEFAULT 0 COMMENT 'Delete action is pertinent',
	PRVN_Notes				boolean				NOT NULL DEFAULT 0 COMMENT 'Notes action is pertinent',
	PRVN_ItemsPerPage		smallint	UNSIGNED	NOT NULL DEFAULT 0 COMMENT 'Default items per page to include; 0 = N/A',
	PRVN_DropDownLimit		smallint	UNSIGNED	NOT NULL DEFAULT 0 COMMENT 'Default drop-down imit (pixels); 0 = N/A',
    PRVN_UpdateUser			varchar(25)			NOT NULL,
    PRVN_UpdateUserIP1		bigint 		UNSIGNED	NULL,
    PRVN_UpdateUserIP2		bigint 		UNSIGNED	NOT NULL,
    PRVN_UpdateTimestamp	timestamp				NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
	FOREIGN KEY fk_PRVN_to_PRVG (PRVN_PRVG_ID) REFERENCES Privilege_Groups (PRVG_ID) ON DELETE CASCADE
)
ENGINE=InnoDB DEFAULT CHARACTER SET utf8 COLLATE utf8_bin COMMENT='Access Privilege Names'
