CREATE TABLE Privilege_Settings
(
	PRVS_ID					tinyint 	UNSIGNED	NOT NULL AUTO_INCREMENT PRIMARY KEY,
	PRVS_PRVN_ID			smallint 	UNSIGNED	NOT NULL 					COMMENT 'Vector to Privilege Name',
	PRVS_PRVT_ID			smallint 	UNSIGNED	NULL 						COMMENT 'Vector to Privilege Template',
	PRVS_USRO_ID			mediumint 	UNSIGNED	NULL 						COMMENT 'Vector to User/Operator',
	PRVS_CategorySeq		smallint 	UNSIGNED	NOT NULL DEFAULT 0 		COMMENT 'Ordinal position within Privilege Group',
	PRVS_FavoriteSeq		tinyint 	UNSIGNED	NOT NULL DEFAULT 0 		COMMENT 'Ordinal position within Favorites Group',
	PRVS_View				boolean				NOT NULL DEFAULT 0 		COMMENT 'View action is allowed',
	PRVS_Add				boolean				NOT NULL DEFAULT 0 		COMMENT 'Add action is allowed',
	PRVS_Edit				boolean				NOT NULL DEFAULT 0 		COMMENT 'Edit action is allowed',
	PRVS_Print				boolean				NOT NULL DEFAULT 0 		COMMENT 'Print action is allowed',
	PRVS_PrintList			boolean				NOT NULL DEFAULT 0 		COMMENT 'Print List action is allowed',
	PRVS_Export				boolean				NOT NULL DEFAULT 0 		COMMENT 'Export action is allowed',
	PRVS_Inactivate			boolean				NOT NULL DEFAULT 0 		COMMENT 'Activate/Inactivate action is allowed',
	PRVS_Delete				boolean				NOT NULL DEFAULT 0 		COMMENT 'Delete action is allowed',
	PRVS_Notes				boolean				NOT NULL DEFAULT 0 		COMMENT 'Notes action is allowed',
	PRVS_ItemsPerPage		smallint 	UNSIGNED	NOT NULL DEFAULT 0 		COMMENT 'Items per page to include; 0 = N/A',
	PRVS_DropDownLimit		smallint 	UNSIGNED	NOT NULL DEFAULT 0 		COMMENT 'Drop-down imit (pixels); 0 = N/A',
	PRVS_PrintListColor		char(5)					NOT NULL DEFAULT 'color'	COMMENT 'Selected color for PrintList option',
    PRVS_UpdateUser			varchar(25)			NOT NULL,
    PRVS_UpdateUserIP1		bigint 		UNSIGNED	NULL,
    PRVS_UpdateUserIP2		bigint 		UNSIGNED	NOT NULL,
    PRVS_UpdateTimestamp	timestamp				NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
 	FOREIGN KEY fk_PRVS_to_PRVN (PRVS_PRVN_ID) REFERENCES Privilege_Names (PRVN_ID) ON DELETE CASCADE,
	FOREIGN KEY fk_PRVS_to_PRVT (PRVS_PRVT_ID) REFERENCES Privilege_Templates (PRVT_ID) ON DELETE SET NULL,
	FOREIGN KEY fk_PRVS_to_USRO (PRVS_USRO_ID) REFERENCES Users_Operators (USRO_ID) ON DELETE CASCADE
)
ENGINE=InnoDB DEFAULT CHARACTER SET utf8 COLLATE utf8_bin COMMENT='Access Privilege Settings'
