CREATE TABLE States
(
	STAT_ID 				mediumint(8) 	UNSIGNED	NOT NULL AUTO_INCREMENT PRIMARY KEY,
	STAT_NATN_ID 			smallint(5) 	UNSIGNED	NOT NULL COMMENT 'Vector to the parent Country',
	STAT_Code 				varchar(5) 				NOT NULL DEFAULT '' COMMENT 'State/province/district code, if applicable',
	STAT_NameToken			varchar(50) 				NOT NULL COMMENT 'Language token for State name',
	STAT_UpdateUser			varchar(25)				NOT NULL,
	STAT_UpdateUserIP1		bigint 			UNSIGNED	NULL,
	STAT_UpdateUserIP2		bigint 			UNSIGNED	NOT NULL,
	STAT_UpdateTimestamp	timestamp					NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
	UNIQUE  KEY uk_NATN_STAT 		(STAT_NATN_ID,STAT_Code),
	FOREIGN KEY fk_STAT_to_NATN 	(STAT_NATN_ID) REFERENCES Countries_Main (NATN_ID) ON DELETE CASCADE
)
ENGINE=InnoDB DEFAULT CHARACTER SET utf8 COLLATE utf8_bin COMMENT='States, provinces, districts for Countries'