CREATE TABLE System_Tokens
(
	SYST_ID 				smallint 	UNSIGNED	NOT NULL AUTO_INCREMENT PRIMARY KEY,
	SYST_SYSC_ID 			tinyint 	UNSIGNED	NOT NULL COMMENT 'Vector to System Parameter Collection',
	SYST_IsMasterOnly		boolean				NOT NULL DEFAULT False COMMENT 'If True, not available to Operators',
	SYST_Token 				varchar(50)			NOT NULL COMMENT 'System Parameter Token (internal variable) name',
	SYST_Type				enum('B','I','S','F')	NOT NULL COMMENT 'System Parameter data type: B(oolean), I(nteger), S(tring), F(loat)',
	SYST_Sequence			smallint 	UNSIGNED	NOT NULL DEFAULT '0' COMMENT 'System Parameter Token sequence override',
	SYST_Notes	 			varchar(250) 			NOT NULL DEFAULT '' COMMENT 'Optional internal notes',
	SYST_UpdateUser			varchar(25)			NOT NULL,
	SYST_UpdateUserIP1		bigint 		UNSIGNED	NULL,
	SYST_UpdateUserIP2		bigint 		UNSIGNED	NOT NULL,
	SYST_UpdateTimestamp	timestamp				NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,

	UNIQUE  KEY uk_SYST_Token (SYST_Token),
	FOREIGN KEY fk_SYST_to_SYSC (SYST_SYSC_ID) REFERENCES System_Collections (SYSC_ID) ON DELETE CASCADE
)
ENGINE=InnoDB DEFAULT CHARACTER SET utf8 COLLATE utf8_bin COMMENT='System Paramter Tokens'