CREATE TABLE Users_Operators
(
	USRO_ID					mediumint UNSIGNED	AUTO_INCREMENT PRIMARY KEY,
    USRO_USRM_ID			mediumint UNSIGNED	NOT NULL 				COMMENT 'Vector to Users_Main',
    USRO_OPRS_ID			mediumint UNSIGNED	NULL 					COMMENT 'Optional vector to Operators',
	USRO_IsAdministrator	boolean			NOT NULL DEFAULT 0,
    USRO_IsInactive			boolean			NOT NULL DEFAULT 0 	COMMENT 'True if User is inactive',
	USRO_InactiveTimestamp	timestamp			NULL 					COMMENT 'Date/time User was inactivated',
	USRO_SkinName			varchar(50)		NOT NULL DEFAULT 'dhx_skyblue',
	USRO_VerboseToolbar		boolean			NOT NULL DEFAULT 1	COMMENT 'True is "verbose" toolbar menus',
	USRO_LoginCount			int UNSIGNED		NOT NULL DEFAULT 0,
	USRO_LastLoginTimestamp	timestamp			NULL 					COMMENT 'Most recent login timestamp',
	USRO_PrevLoginTimestamp	timestamp			NULL 					COMMENT 'Previous login timestamp',
    USRO_LastLoginIP1		bigint UNSIGNED		NULL,
    USRO_LastLoginIP2		bigint UNSIGNED		NULL,
    USRO_PrevLoginIP1		bigint UNSIGNED		NULL,
    USRO_PrevLoginIP2		bigint UNSIGNED		NULL,

	UNIQUE KEY  uk_USRO (USRO_USRM_ID, USRO_OPRS_ID),
    FOREIGN KEY fk_USRO_to_OPRS (USRO_OPRS_ID) REFERENCES Operators  (OPRS_ID) ON DELETE CASCADE,
    FOREIGN KEY fk_USRO_to_USRM (USRO_USRM_ID) REFERENCES Users_Main (USRM_ID) ON DELETE CASCADE
)
ENGINE=InnoDB DEFAULT CHARACTER SET utf8 COLLATE utf8_bin COMMENT='System User/Operator Links'
