<?php

// get configuration data
include("../Helpers/config.php");

// light the fires 'n' check the tires
include("adminlib.php");

// load up all the language-specific stuff
include("../getlang.php");

// bootstrap some language settings until we can get the data loaded
if (!isset($QUERY_FAILURE)) 		{$QUERY_FAILURE 		= "Query failure";}
if (!isset($BAD_DB_CONNECT))		{$BAD_DB_CONNECT		= "Unable to connect to the MAESS database.";}
if (!isset($ERROR_REASON_PREFIX))	{$ERROR_REASON_PREFIX 	= "Reason";}
if (!isset($LABEL_DELIM))			{$LABEL_DELIM 			= ":";}

// some field limits (keep in sync with schema!)
define("TBLS_NAME_LENGTH"		,  50);
define("TBLS_DESC_LENGTH"		,2000);
define("NATN_CODE_LENGTH"		,   2);
define("NATN_ISO3_LENGTH"		,   3);
define("NATN_FIPS_LENGTH"		,   2);
define("NATN_NAMETOKEN_LENGTH"	,  50);
define("NATN_STATETOKEN_LENGTH",  50);
define("NATN_ZIPTOKEN_LENGTH"	,  50);
define("NATN_SITA_LENGTH"		,   7);
define("NATN_AFTN_LENGTH"		, 100);
define("STAT_CODE_LENGTH"		,   5);
define("STAT_NAMETOKEN_LENGTH"	,  50);
define("SNDS_TYPE_LENGTH"		,   1);
define("SNDS_NAME_LENGTH"		, 100);
define("SNDS_DESC_LENGTH"		,1000);
define("PRVG_TOKEN_LENGTH"		,  50);
define("PRVG_DESC_LENGTH"		, 150);
define("PRVN_TOKEN_LENGTH"		,  50);
define("PRVN_PROGRAM_LENGTH"	, 100);
define("CHGH_SUMMARY_LENGTH"	, 100);

// initiate the database connection
$dbconn = my_db_connect ($database_host, $database_name, $database_username, $database_password);

$addedOperators = array();

echo "<html><body>Deleting tables...<br/>";
@ob_flush();
@flush();

// Delete all tables
// (in some cases, sequence is important!)

Drop_Table ("Language", array("Values", "Sets", "Tokens", "Collections", "Names"));

Drop_Table ("System_Changes");

Drop_Table ("Audit_Log");
Drop_Table ("System_Tables");
Drop_Table ("SysRefs", array("Values", "Sets", "Operators", "Main"));

Drop_Table ("System", array("Values", "Settings", "Tokens", "Collections"));

Drop_Table ("Privilege", array("Settings", "Names", "Groups", "Templates"));
Drop_Table ("Users", array("Passwords", "Operators", "Main"));

Drop_table ("Airports_Operators");
Drop_Table ("Countries_Operators");
Drop_Table ("Airports");
Drop_Table ("Operators");
Drop_Table ("States");
Drop_Table ("Countries_Main");
Drop_Table ("System_Sounds");

echo "Creating tables & stored routines...<br/>";
@ob_flush();
@flush();

// Create all tables
// (in some cases, sequence is important!)

// SYSTEM AUDIT LOG TABLE

    Add_Table("AUDT");
    Add_StoredRoutine("proc", "AUDT_Insert");

// SYSTEM CHANGES ABLE

    Add_Table("CHGH");
    //Add_Audit_Triggers("System_Changes", "CHGH");
    Add_StoredRoutine("proc", "CHGH_Update");
	Add_StoredRoutine("proc", "CHGH_Delete");

// SYSTEM TABLES TABLE

    Add_Table("TBLS");
    Add_Audit_Triggers("System_Tables", "TBLS");
    Add_StoredRoutine("proc", "TBLS_Update");
	Add_StoredRoutine("proc", "TBLS_ChangeState");
	Add_StoredRoutine("proc", "TBLS_Delete");

// COUNTRIES TABLE (And related...)

    Add_Table("NATN");
    Add_Audit_Triggers("Countries_Main", "NATN");
    Add_StoredRoutine("proc", "NATN_Update");
	Add_StoredRoutine("proc", "NATN_Delete");

// STATES TABLE

    Add_Table("STAT");
    Add_Audit_Triggers("States", "STAT");
    Add_StoredRoutine("proc", "STAT_Update");

// AIRPORTS TABLE (And related...)

    Add_Table("ARPT");
    Add_Audit_Triggers("Airports", "ARPT");

// OPERATORS TABLE

    Add_Table("OPRS");
    Add_Audit_Triggers("Operators", "OPRS");
    Add_StoredRoutine("proc", "OPRS_Update");

    Add_Table("NATO");
    Add_Audit_Triggers("Countries_Operators", "NATO");

    Add_Table("ARPO");
    Add_Audit_Triggers("Airports_Operators", "ARPO");

    Add_StoredRoutine("proc", "NATN_GetPricing");

// LANGUAGE SUPPORT TABLES - NAMES

    Add_Table("LNGN");
    Add_Audit_Triggers("Language_Names", "LNGN");
    Add_StoredRoutine("proc", "LNGN_Update");

// LANGUAGE SUPPORT TABLES - SETS

    Add_Table("LNGS");
    // no last-update info (or related triggers) since this is a x-ref table
    Add_StoredRoutine("proc", "LNGS_Insert");

// LANGUAGE SUPPORT TABLES - COLLECTIONS

    Add_Table("LNGC");
    Add_Audit_Triggers("Language_Collections", "LNGC");
    Add_StoredRoutine("proc", "LNGC_Update");

// LANGUAGE SUPPORT TABLES - TOKENS

    Add_Table("LNGT");
    Add_Audit_Triggers("Language_Tokens", "LNGT");
    Add_StoredRoutine("proc", "LNGT_Update");

// LANGUAGE SUPPORT TABLES - VALUES

    Add_Table("LNGV");
    Add_Audit_Triggers("Language_Values", "LNGV");
    Add_StoredRoutine("proc", "LNGV_Update");

// OTHER PROCS RELATED TO LANGUAGE SUPPORT

    Add_StoredRoutine("proc", "LNGN_GetLanguageList");
    Add_StoredRoutine("proc", "LNGV_ListByLanguages");
    Add_StoredRoutine("func", "GET_LANGUAGE_TEXT");

// SYSTEM SETTINGS TABLES - SETTINGS

    Add_Table("SYSS");
    // no last-update info (or related triggers) since this is basically a x-ref table

    // go ahead and stick in the master set instance
    $query = "INSERT INTO System_Settings (SYSS_OPRS_ID) VALUES(NULL)";
    if (!$dbconn->query ($query)) {Fatal_SQL_Error($query);}

// SYSTEM SETTINGS TABLES - COLLECTIONS

    Add_Table("SYSC");
    Add_Audit_Triggers("System_Collections", "SYSC");
    Add_StoredRoutine("proc", "SYSC_Update");

// SYSTEM SETTINGS TABLES - TOKENS

    Add_Table("SYST");
    Add_Audit_Triggers("System_Tokens", "SYST");
    Add_StoredRoutine("proc", "SYST_Update");

// SYSTEM SETTINGS TABLES - VALUES

    Add_Table("SYSV");
    Add_Audit_Triggers("System_Values","SYSV");
    Add_StoredRoutine("proc", "SYSV_Update");

// SYSTEM REFERENCE GROUPS

    Add_Table("SYRF");
  	Add_Audit_Triggers("SysRefs_Main", "SYRF");
    Add_Table("SYRO");
	Add_Table("SYRS");
    Add_Table("SYRV");
  	Add_Audit_Triggers("SysRefs_Sets", "SYRS");
    Add_StoredRoutine("proc", "SYRF_Update");
    Add_StoredRoutine("proc", "SYRF_Delete");
	Add_StoredRoutine("proc", "SYRV_InitializeNewOperator");


// SYSTEM USERS - MAIN

    Add_Table("USRM");
    Add_Audit_Triggers("Users_Main", "USRM");
	Add_StoredRoutine("proc", "USRM_Update");
	Add_StoredRoutine("proc", "USRM_ChangeState");

// SYSTEM USERS - PASSWORDS

    Add_Table("USRP");
	Add_StoredRoutine("proc", "USRP_AddPassword");

// SYSTEM USERS - OPERATORS LINKS

    Add_Table("USRO");

// PRIVILEGE MANAGEMENT - GROUPS

    Add_Table("PRVG");
    Add_Audit_Triggers("Privilege_Groups", "PRVG");
	Add_StoredRoutine("proc", "PRVG_Update");
	Add_StoredRoutine("proc", "PRVG_Delete");

// PRIVILEGE MANAGEMENT - NAMES

    Add_Table("PRVN");
    Add_Audit_Triggers("Privilege_Names", "PRVN");
	Add_StoredRoutine("proc", "PRVN_Update");

// PRIVLEGE MANAGEMENT - TEMPLATES

    Add_Table("PRVT");
    Add_Audit_Triggers("Privilege_Templates", "PRVT");

// PRIVLEGE MANAGEMENT - SETTINGS

    Add_Table("PRVS");
    Add_Audit_Triggers("Privilege_Settings", "PRVS");
	Add_StoredRoutine("proc", "PRVS_SetForAdmin");

// SYSTEM SOUNDS

    Add_Table("SNDS");
    Add_Audit_Triggers("System_Sounds", "SNDS");
	Add_StoredRoutine("proc", "SNDS_Update");
	Add_StoredRoutine("proc", "SNDS_GetRandomSound");

// NOW SOME MISC STUFF

	Add_StoredRoutine("proc", "PRVS_GetPrivileges");
	Add_StoredRoutine("proc", "PRVS_UpdateMenu");
	Add_StoredRoutine("func", "ORDERED_NAME");
	//Add_StoredRoutine("func", "DATE_FROM_GMT");

echo "Loading data...<br/>";
@ob_flush();
@flush();

// LOAD SOME DEFAULT DATA

// access the default data XML file
$xml = simplexml_load_file("tabledefaults.xml");
foreach ($xml->children() as $datatype)
  {
  // loops through each category of default data
  foreach ($datatype->children() as $dataelement)
  	{
    // first collect each category's field values
    unset ($attrarray);
    foreach ($dataelement->attributes() as $attr => $val) {$attrarray[strtolower($attr)] = addslashes(trim($val));}
    // determine what to do with them
		switch ($dataelement->getName())
		{
    		/////////////////////////////////////
			// handle system changes data here //
			/////////////////////////////////////
			case "syschange":

            if (!array_key_exists('date',$attrarray) || !array_key_exists('summary',$attrarray))
            {Generate_DataLoad_Error($attrarray, "syschange", ""); break;}
			$chgDate = strtotime($attrarray['date']);
			if (false === $chgDate)
            {Generate_DataLoad_Error($attrarray, "syschange", "date is inavlid"); break;}
            if (array_key_exists('internalonly',$attrarray))
            {
            	if (!(strtoupper($attrarray['internalonly']) == "TRUE" || strtoupper($attrarray['internalonly']) == "FALSE")) {Generate_DataLoad_Error($attrarray, "syschange", "internalonly attribute is invalid"); break;}
            }
            $intOnly = array_key_exists('internalonly',$attrarray) ? (strtoupper($attrarray['internalonly']) == "TRUE" ? 1 : 0) : 0;

            // add the entry
            $query = "CALL CHGH_Update (0,CONVERT_TZ(STR_TO_DATE('" . date("n/j/Y", $chgDate) . " 00:00:00','%c/%e/%Y %H:%i:%S'),'America/Chicago','GMT')," . $intOnly . ",'" . substr($attrarray['summary'],0,CHGH_SUMMARY_LENGTH) ."','{$rsvusername['setup']}','{$ipbins[0]}','{$ipbins[1]}','" . $attrarray['details'] . "',NULL);";
			if (!$dbconn->multi_query ($query)) {Fatal_SQL_Error($query);}
            do { if ($result = $dbconn->use_result()) { while ($row = $result->fetch_row()) { $systableid = $row[0]; } } } while ($dbconn->next_result());
			break;

    		////////////////////////////////////
			// handle system tables data here //
			////////////////////////////////////
			case "table":

            if (!array_key_exists('code',$attrarray) || !array_key_exists('name',$attrarray))
            {Generate_DataLoad_Error($attrarray, "table", ""); break;}

            // add the entry
            $query = "CALL TBLS_Update (0,'" . substr($attrarray['code'],0,4) . "','" . substr($attrarray['name'],0,TBLS_NAME_LENGTH) ."','" . substr($attrarray['desc'],0,TBLS_DESC_LENGTH) . "','{$rsvusername['setup']}','{$ipbins[0]}','{$ipbins[1]}');";
			if (!$dbconn->multi_query ($query)) {Fatal_SQL_Error($query);}
            do { if ($result = $dbconn->use_result()) { while ($row = $result->fetch_row()) { $systableid = $row[0]; } } } while ($dbconn->next_result());
			break;

    		//////////////////////////////
			// handle country data here //
			//////////////////////////////
			case "country":

            if (!array_key_exists('code',$attrarray) || !array_key_exists('nametoken',$attrarray))
            {Generate_DataLoad_Error($attrarray, "country", ""); break;}
            if (!preg_match(VARNAME_PATTERN, $attrarray['nametoken'] . $attrarray['statetoken'] . $attrarray['ziptoken']))
    		{Generate_DataLoad_Error($attrarray, "country", "one or more language tokens contain invalid characters"); break;}

            $statecodesize 	= array_key_exists('statecodesize',	$attrarray) ? $attrarray['statecodesize']	: 0;
            $pseudo  		= array_key_exists('pseudoparent',	$attrarray) ? $attrarray['pseudoparent']   	: "NULL";

            // if pseudo country, ensure parent country present and accounted for
            if ($pseudo != "NULL")
			{
                $query  = "SELECT NATN_ID FROM Countries_Main WHERE NATN_Code = '$pseudo'";
                $result = $dbconn->query ($query) or Fatal_SQL_Error($query);
            	if ($result->num_rows == 0) {Generate_DataLoad_Error($attrarray, "country", "pseudoparent country code not found"); break;}
					else
                {
                	// found, get NATN_ID of parent
               	 	$row 	= $result->fetch_row();
                	$pseudo = $row[0];
                }
			}
            // add the entry
            $query = "CALL NATN_Update (0,'" . substr($attrarray['code'],0,NATN_CODE_LENGTH) . "','" . substr($attrarray['iso3'],0,NATN_ISO3_LENGTH) . "','',$pseudo,$statecodesize,'" . substr($attrarray['nametoken'],0,NATN_NAMETOKEN_LENGTH) . "','" . substr($attrarray['statetoken'],0,NATN_STATETOKEN_LENGTH) . "','" . substr($attrarray['ziptoken'],0,NATN_ZIPTOKEN_LENGTH) . "','{$rsvusername['setup']}','{$ipbins[0]}','{$ipbins[1]}');";
			if (!$dbconn->multi_query ($query)) {Fatal_SQL_Error($query);}
            // get the returned NATN_ID
            do { if ($result = $dbconn->use_result()) { while ($row = $result->fetch_row()) { $countryid = $row[0]; } } } while ($dbconn->next_result());
            break;

            ////////////////////////////
            // handle state data here //
            ////////////////////////////
        	case "state":

        	if (!array_key_exists('code',$attrarray) || !array_key_exists('nametoken',$attrarray) || !array_key_exists('country',$attrarray))
            {Generate_DataLoad_Error($attrarray, "state", ""); break;}
			if (!preg_match(VARNAME_PATTERN, $attrarray['nametoken']))
    		{Generate_DataLoad_Error($attrarray, "state", "one or more language tokens contain invalid characters"); break;}

            $query = "SELECT NATN_ID, NATN_StateCodeLength FROM Countries_Main WHERE NATN_Code = '" . $attrarray['country'] . "'";
            $result = $dbconn->query ($query) or Fatal_SQL_Error($query);
            if ($result->num_rows == 0) {Generate_DataLoad_Error($attrarray, "state", "country not found"); break;}

            // found, get parent country info
            $row 		= $result->fetch_array(MYSQLI_ASSOC);
            $country 	= $row['NATN_ID'];
			$statecode 	= ($row['NATN_StateCodeLength'] == 0 ? "NULL" : ("'" . substr($attrarray['code'], 0, $row['NATN_StateCodeLength']) . "'"));

			// add the state
            $query = "CALL STAT_Update (0,$country,'" . substr($attrarray['code'],0,STAT_CODE_LENGTH) . "','" . substr($attrarray['nametoken'],0,STAT_NAMETOKEN_LENGTH) . "','{$rsvusername['setup']}','{$ipbins[0]}','{$ipbins[1]}');";
            if (!$dbconn->multi_query ($query)) {Fatal_SQL_Error($query);}
            // get the returned NATN_ID
            do { if ($result = $dbconn->use_result()) { while ($row = $result->fetch_row()) { $stateid = $row[0]; } } } while ($dbconn->next_result());
            break;

    		///////////////////////////////////////
			// handle privilege groups data here //
			///////////////////////////////////////
			case "privGroup":
        	if (!array_key_exists('token',$attrarray))
            {Generate_DataLoad_Error($attrarray, "privGroup", ""); break;}
			if (!preg_match(VARNAME_PATTERN, $attrarray['token']))
    		{Generate_DataLoad_Error($attrarray, "privGroup", "the group token contains one or more invalid characters"); break;}

			// limit possible sequence
			$seq = $attrarray['seq'] > DATA_SEQUENCE_CEILING ? 0 : $attrarray['seq'];
			// add the group
            $query = "CALL PRVG_Update (0,'" . substr($attrarray['token'],0,PRVG_TOKEN_LENGTH) . "',$seq,'" . substr($attrarray['desc'],0,PRVG_DESC_LENGTH) . "','{$rsvusername['setup']}','{$ipbins[0]}','{$ipbins[1]}');";
            if (!$dbconn->multi_query ($query)) {Fatal_SQL_Error($query);}
            // get the returned PRVG_ID
            do { if ($result = $dbconn->use_result()) { while ($row = $result->fetch_row()) { $prvgid = $row[0]; } } } while ($dbconn->next_result());
			break;

    		//////////////////////////////////////
			// handle privilege names data here //
			//////////////////////////////////////
			case "privFunction":
        	if (!array_key_exists('token',$attrarray) || !array_key_exists('group',$attrarray) || !array_key_exists('accesses',$attrarray) || !array_key_exists('program',$attrarray))
            {Generate_DataLoad_Error($attrarray, "privFunction", ""); break;}
			if (!preg_match(VARNAME_PATTERN, $attrarray['token']))
    		{Generate_DataLoad_Error($attrarray, "privFunction", "the name token contains one or more invalid characters"); break;}
			if (!ctype_digit($attrarray['ipp']) || $attrarray['ipp'] > 249)
    		{Generate_DataLoad_Error($attrarray, "privFunction", "the IPP value must be a positive numeric value < 250"); break;}
			if (!ctype_digit($attrarray['ddl']) || $attrarray['ddl'] > 999)
    		{Generate_DataLoad_Error($attrarray, "privFunction", "the DDL value must be a positive numeric value < 1000"); break;}
            if (array_key_exists('hidden',$attrarray))
            {
            	$attrarray['hidden'] = strtoupper($attrarray['hidden']);
            	if (!($attrarray['hidden'] == "TRUE" || $attrarray['hidden'] == "FALSE")) {Generate_DataLoad_Error($attrarray, "setting", "hidden attribute is invalid"); break;}
            }
            if (array_key_exists('superonly',$attrarray))
            {
            	$attrarray['superonly'] = strtoupper($attrarray['superonly']);
            	if (!($attrarray['superonly'] == "TRUE" || $attrarray['superonly'] == "FALSE")) {Generate_DataLoad_Error($attrarray, "setting", "superonly attribute is invalid"); break;}
            }

			$attrarray['accesses'] = strtoupper($attrarray['accesses']);
			$A = strripos($attrarray['accesses'],"A") === false ? 0 : 1;
			$E = strripos($attrarray['accesses'],"E") === false ? 0 : 1;
			$P = strripos($attrarray['accesses'],"P") === false ? 0 : 1;
			$L = strripos($attrarray['accesses'],"L") === false ? 0 : 1;
			$X = strripos($attrarray['accesses'],"X") === false ? 0 : 1;
			$I = strripos($attrarray['accesses'],"I") === false ? 0 : 1;
			$D = strripos($attrarray['accesses'],"D") === false ? 0 : 1;
			$N = strripos($attrarray['accesses'],"N") === false ? 0 : 1;
			if ($attrarray['token'] == "PRVN_Groups") {echo ("array=" . $attrarray['accesses'] . ",stripos value=" . strripos($attrarray['accesses'],"A") . ", A=" . $A . "<br>");}

			// limit possible sequence
			$seq = $attrarray['seq'] > DATA_SEQUENCE_CEILING ? 0 : $attrarray['seq'];

            // look for the privilege group
			$query = "SELECT PRVG_ID FROM Privilege_Groups WHERE PRVG_Token = '" . $attrarray['group'] . "'";
            $result = $dbconn->query ($query) or Fatal_SQL_Error($query);
            if ($result->num_rows == 0) {Generate_DataLoad_Error($attrarray, "privFunction", "group not found"); break;}

            // found, get group id
            $row 		= $result->fetch_array(MYSQLI_ASSOC);
            $privgroup 	= $row['PRVG_ID'];

			// add the name
    		// (PRVGID,Token,Sequence,Program,SuperUserOnly,IncludeInMenu,Pseudo,Add,Edit,Print,PrintList,Export,Inactivate,Delete,Notes,ItemsPerPage,DropDownLimit,UpdateUser,IP1,IP2)
            $query = "CALL PRVN_Update (0,$privgroup,'" . substr($attrarray['token'],0,PRVN_TOKEN_LENGTH) . "',$seq,'" . substr($attrarray['program'],0,PRVN_PROGRAM_LENGTH) . "'," . ($attrarray['superonly']=="TRUE" ? 1 : 0)  . "," . ($attrarray['hidden']=="FALSE" ? 1 : 0) . ",0,$A,$E,$P,$L,$X,$I,$D,$N,{$attrarray['ipp']},{$attrarray['ddl']},'{$rsvusername['setup']}','{$ipbins[0]}','{$ipbins[1]}');";
			if (!$dbconn->multi_query ($query)) {Fatal_SQL_Error($query);}
            // get the returned PRVN_ID
            do { if ($result = $dbconn->use_result()) { while ($row = $result->fetch_row()) { $prvnid = $row[0]; } } } while ($dbconn->next_result());
			break;

    		///////////////////////////
			// handle operators here //
			///////////////////////////
			case "operator":
        	if (!array_key_exists('name',$attrarray) || !array_key_exists('legalname',$attrarray) || !array_key_exists('addr1',$attrarray) || !array_key_exists('city',$attrarray) || !array_key_exists('state',$attrarray))
            {Generate_DataLoad_Error($attrarray, "operator", ""); break;}

			// find the state
			$query = "SELECT STAT_ID FROM States WHERE STAT_Code = '" . strtoupper($attrarray['state']) . "'";
            if (!$dbconn->multi_query ($query)) {Fatal_SQL_Error($query);}
            do { if ($result = $dbconn->use_result()) { while ($row = $result->fetch_row()) { $statid = $row[0]; } } } while ($dbconn->next_result());
			// now add the operator  (country = US)
			$query = "INSERT INTO Operators (OPRS_LegalName, OPRS_ShortName, OPRS_AddressLine1, OPRS_City, OPRS_StateID, OPRS_CountryID, OPRS_UpdateUser, OPRS_UpdateUserIP1, OPRS_UpdateUserIP2, OPRS_UpdateTimestamp) VALUES"
			       . "('" . addslashes($attrarray['legalname']) . "', '" . addslashes($attrarray['name']) . "', '" . addslashes($attrarray['addr1']) . "', '" . addslashes($attrarray['city']) . "', $stateid, (SELECT NATN_ID FROM Countries_Main WHERE NATN_Code = 'US'), '{$rsvusername['setup']}', NULLIF(CONV({$ipbins[0]},2,10),0), CONV({$ipbins[1]},2,10), UTC_TIMESTAMP())";
            if (!$dbconn->multi_query ($query)) {Fatal_SQL_Error($query);}
			// get the OPRS_ID
			$query = "SELECT LAST_INSERT_ID();";
			$result = mysqli_query ($dbconn, $query);
			if (!$result) {Fatal_SQL_Error($query);}
			$row = mysqli_fetch_row($result);
			$addedOperators[count($addedOperators)] = $row[0];
			break;

    		////////////////////////
			// handle users here  //
			////////////////////////
			case "user":
        	if (!array_key_exists('name',$attrarray) || !array_key_exists('fname',$attrarray) || !array_key_exists('lname',$attrarray) || !array_key_exists('gender',$attrarray) || !array_key_exists('email',$attrarray))
            {Generate_DataLoad_Error($attrarray, "user", ""); break;}
            if (array_key_exists('su',$attrarray))
            {
            	if (!(strtoupper($attrarray['su']) == "TRUE" || strtoupper($attrarray['su']) == "FALSE")) {Generate_DataLoad_Error($attrarray, "user", "su attribute is invalid"); break;}
            }
            $su = array_key_exists('su',$attrarray) ? (strtoupper($attrarray['su']) == "TRUE" ? 1 : 0) : 0;
			// store the user
			$query  = "INSERT INTO Users_Main (USRM_Name, USRM_EmailPrimary, USRM_IsSuperUser, USRM_TimeZone, USRM_NameFirst, USRM_NameLast, USRM_Gender, USRM_UpdateUser, USRM_UpdateUserIP1, USRM_UpdateUserIP2, USRM_UpdateTimestamp) VALUES"
					. "('" . addslashes($attrarray['name']) . "', '" . addslashes($attrarray['email']) . "', $su, 'America/Chicago', '" . addslashes($attrarray['fname']) . "', '" . addslashes($attrarray['lname']) . "', '" . $attrarray['gender'] . "', '{$rsvusername['setup']}', NULLIF(CONV({$ipbins[0]},2,10),0), CONV({$ipbins[1]},2,10), UTC_TIMESTAMP())";
            if (!$dbconn->multi_query ($query)) {Fatal_SQL_Error($query);}
			// get the USRM_ID
			$query = "SELECT LAST_INSERT_ID();";
			$result = mysqli_query ($dbconn, $query);
			if (!$result) {Fatal_SQL_Error($query);}
			$row = mysqli_fetch_row($result);
			$usrmid = $row[0];
			// now store a password ($rccmaess)
			$query = "INSERT INTO Users_Passwords (USRP_USRM_ID, USRP_SeqNo, USRP_Password) VALUES ($usrmid, 1, '5af519b176739b9cfd53e282c611f682')";
			if (!$dbconn->query ($query)) {Fatal_SQL_Error($query);}
			// if superuser, insert USRO instance and set access privileges
			if ($su)
			{
				// need an operator-less USRO instance
				$query = "INSERT INTO Users_Operators (USRO_USRM_ID) VALUES ($usrmid)";
				if (!$dbconn->query ($query)) {Fatal_SQL_Error($query);}
				// now set all the access privileges for a superuser
				$query = "CALL PRVS_SetForAdmin ((SELECT USRO_ID FROM Users_Operators WHERE USRO_OPRS_ID IS NULL AND USRO_USRM_ID = $usrmid),'S','{$ipbins[0]}','{$ipbins[1]}');";
				if (!$dbconn->query ($query)) {Fatal_SQL_Error($query);}
			}
			break;

    		/////////////////////////////
			// handle user links here  //
			////////////////////////////
			case "userlink":
        	if (!array_key_exists('user',$attrarray) || !array_key_exists('operator',$attrarray))
            {Generate_DataLoad_Error($attrarray, "userlink", ""); break;}
            if (array_key_exists('admin',$attrarray))
            {
            	if (!(strtoupper($attrarray['admin']) == "TRUE" || strtoupper($attrarray['admin']) == "FALSE")) {Generate_DataLoad_Error($attrarray, "userlink", "admin attribute is invalid"); break;}
            }
            $admin = array_key_exists('admin',$attrarray) ? (strtoupper($attrarray['admin']) == "TRUE" ? 1 : 0) : 0;
			// find the user
			$usrmid = 0;
			$query = "SELECT USRM_ID FROM Users_Main WHERE UPPER(USRM_Name) = '" . strtoupper($attrarray['user']) . "'";
            if (!$dbconn->multi_query ($query)) {Fatal_SQL_Error($query);}
            do { if ($result = $dbconn->use_result()) { while ($row = $result->fetch_row()) { $usrmid = $row[0]; } } } while ($dbconn->next_result());
			if (0 == $usrmid) {Generate_DataLoad_Error($attrarray, "userlink", "user not found"); break;}
			// find the operator
			$oprsid = 0;
			$query = "SELECT OPRS_ID FROM Operators WHERE UPPER(OPRS_ShortName) = '" . strtoupper($attrarray['operator']) . "'";
            if (!$dbconn->multi_query ($query)) {Fatal_SQL_Error($query);}
            do { if ($result = $dbconn->use_result()) { while ($row = $result->fetch_row()) { $oprsid = $row[0]; } } } while ($dbconn->next_result());
			if (0 == $oprsid) {Generate_DataLoad_Error($attrarray, "userlink", "operator not found"); break;}
			// insert the USRO instance
			$query = "INSERT INTO Users_Operators (USRO_USRM_ID, USRO_OPRS_ID, USRO_IsAdministrator) VALUES ($usrmid, $oprsid, $admin)";
			if (!$dbconn->query ($query)) {Fatal_SQL_Error($query);}
			// set all privileges (even if not admin, just for testing
			$query = "CALL PRVS_SetForAdmin ((SELECT USRO_ID FROM Users_Operators WHERE USRO_OPRS_ID = $oprsid AND USRO_USRM_ID = $usrmid),'A','{$ipbins[0]}','{$ipbins[1]}');";
			if (!$dbconn->query ($query)) {Fatal_SQL_Error($query);}
			break;

    		//////////////////////////////////////////
			// handle system reference groups here  //
			/////////////////////////////////////////
			case "sysrefgroup":
        	if (!array_key_exists('type',$attrarray) || !array_key_exists('name',$attrarray) || !array_key_exists('vals',$attrarray) || !array_key_exists('valtypes',$attrarray) || !array_key_exists('vallabels',$attrarray))
				{Generate_DataLoad_Error($attrarray, "sysrefgroup", ""); break;}
			// edit type
			if ((0 == intval(trim($attrarray['type'])) || intval(trim($attrarray['type'])) > 9999) && "0" != trim($attrarray['type']))
				{Generate_DataLoad_Error($attrarray, "sysrefvalue", "type must be integer > 0 and <= 9999"); break;}
			// edit check vals
			if (0 == intval(trim($attrarray['vals'])))
				{Generate_DataLoad_Error($attrarray, "sysrefvalue", "vals must be numeric > 0"); break;}
			// edit check valtypes
			$typesArray = explode("|", trim($attrarray['valtypes']));
			if (count($typesArray) != intval(trim($attrarray['vals'])))
				{Generate_DataLoad_Error($attrarray, "sysrefvalue", "# valTypes must match vals"); break;}
			for ($i = 0; $i < count($typesArray); $i++)
			{
				if (0 == preg_match("/$typesArray[$i]/i", "INSDB")) {Generate_DataLoad_Error($attrarray, "sysrefvalue", "invalid valtypes"); break;}
			}
			// edit check vallabels
			$typesArray = explode("|", trim($attrarray['vallabels']));
			if (count($typesArray) != intval(trim($attrarray['vals'])))
				{Generate_DataLoad_Error($attrarray, "sysrefvalue", "# valLabels must match vals"); break;}
			// ok to go
			AddSystemRef(trim($attrarray['type']), trim($attrarray['name']), trim($attrarray['vals']), trim($attrarray['valtypes']), trim($attrarray['vallabels']), trim($attrarray['program']), trim($attrarray['delsql']));
			break;

    		///////////////////////////////////////////
			// handle system reference values here  //
			//////////////////////////////////////////
			case "sysrefvalue":
        	if (!array_key_exists('type',$attrarray) || !array_key_exists('seq',$attrarray) || !array_key_exists('values',$attrarray))
				{Generate_DataLoad_Error($attrarray, "sysrefvalue", ""); break;}
			$valArray = explode("|", $attrarray['values']);
			if (0 == intval(trim($attrarray['type'])))
				{Generate_DataLoad_Error($attrarray, "sysrefvalue", "invalid type"); break;}
			if (0 == intval(trim($attrarray['seq'])) || intval(trim($attrarray['seq'])) > 999)
				{Generate_DataLoad_Error($attrarray, "sysrefvalue", "seq must be integer > 0 and <= 9999"); break;}
			if (array_key_exists('required',$attrarray))
            {
            	if (!(strtoupper($attrarray['required']) == "TRUE" || strtoupper($attrarray['required']) == "FALSE")) {Generate_DataLoad_Error($attrarray, "sysrefvalue", "required attribute is invalid"); break;}
            }
			$required = array_key_exists('required',$attrarray) ? (strtoupper($attrarray['required']) == "TRUE" ? 1 : 0) : 0;
			// need to know required # values
			$query = "SELECT SYRF_ValueCount FROM SysRefs_main WHERE SYRF_Type = " . trim($attrarray['type']) . "";
			$result = $dbconn->query ($query) or Fatal_SQL_Error($query);
            if ($result->num_rows == 0)
				{Generate_DataLoad_Error($attrarray, "sysrefvalue", "type not found"); break;}
			$row = $result->fetch_array(MYSQLI_ASSOC);
			// do we have that many values?
			if (count($valArray) != $row['SYRF_ValueCount'])
				{Generate_DataLoad_Error($attrarray, "sysrefvalue", "incorrect # values specified"); break;}
			// ok, add 'em all
			for ($i = 0; $i < count($valArray); $i++) {$valArray[$i] = trim($valArray[$i]);}
			AddSystemRefDefault(trim($attrarray['type']), $required, trim($attrarray['seq']), $valArray);
			break;

    		/////////////////////////////
			// handle sounds data here //
			/////////////////////////////
			case "sound":
        	if (!array_key_exists('type',$attrarray) || !array_key_exists('name',$attrarray))
            {Generate_DataLoad_Error($attrarray, "sound", ""); break;}
			// add the sound
            $query = "CALL SNDS_Update (0,'" . substr($attrarray['type'],0,SNDS_TYPE_LENGTH) . "','" . substr($attrarray['name'],0,SNDS_NAME_LENGTH) . "','" . substr($attrarray['desc'],0,SNDS_DESC_LENGTH) . "','{$rsvusername['setup']}','{$ipbins[0]}','{$ipbins[1]}');";
            if (!$dbconn->multi_query ($query)) {Fatal_SQL_Error($query);}
            // get the returned SNDS_ID
            do { if ($result = $dbconn->use_result()) { while ($row = $result->fetch_row()) { $soundid = $row[0]; } } } while ($dbconn->next_result());
			break;
		}
    }
  }

// and, speaking of reference values, let's copy the defaults to each operator so they have a working set to begin with

for ($i = 0; $i < count($addedOperators); $i++)
{
	$query = "CALL SYRV_InitializeNewOperator ({$addedOperators[$i]}, '{$rsvusername['setup']}', '{$ipbins[0]}', '{$ipbins[1]}');";
	if (!$dbconn->query ($query)) {Fatal_SQL_Error($query);}
}

// all done

echo "Done!</body></html>";


/* INTERNAL FUNCTIONS */

///////////////////////////////////////////////////////////////////////////////////
// Add System Reference Types and Values
///////////////////////////////////////////////////////////////////////////////////

function AddSystemRef($refType, $refName, $valCount, $valTypes, $valLabels, $updProg, $delSQL)
{
	global $dbconn, $ipbins, $rsvusername;

	$updProg = (""!=$updProg) ? ("'" . $updProg . "'") : "NULL";
	$delSQL  = (""!=$delSQL ) ? ("'" . $delSQL  . "'") : "NULL";

	// add the SYRF instance and get the key value
	$query = "CALL SYRF_Update(0, $refType, '$refName', 0, $valCount, '$valTypes', '$valLabels', $updProg, $delSQL, '', '{$rsvusername['setup']}', '{$ipbins[0]}', '{$ipbins[1]}');";
    $result = mysqli_query ($dbconn, $query);
	if (!$result) {Fatal_SQL_Error($query);}
	while($row = mysqli_fetch_row($result)) { $sysrefid = $row[0]; }
	$dbconn->next_result();

	return;
}

function AddSystemRefDefault($refType, $required, $sequence, $values)
{
	global $dbconn, $ipbins, $rsvusername;

	// need the SysRefs_Sets instance first
	$query = "INSERT INTO SysRefs_Sets (SYRS_SYRO_ID, SYRS_IsRequired, SYRS_Sequence, SYRS_UpdateUser, SYRS_UpdateUserIP1, SYRS_UpdateUserIP2, SYRS_UpdateTimestamp)"
		   . "\n VALUES ("
		   . "\n (SELECT SYRO_ID FROM SysRefs_Operators WHERE SYRO_SYRF_ID = (SELECT SYRF_ID FROM SysRefs_Main WHERE SYRF_Type = $refType) AND SYRO_OPRS_ID IS NULL), $required, $sequence, '{$rsvusername['setup']}', NULLIF(CONV({$ipbins[0]},2,10),0), CONV({$ipbins[1]},2,10), UTC_TIMESTAMP()"
		   . "\n )";
	if (!$dbconn->query ($query)) {Fatal_SQL_Error($query);}
	$query = "SELECT LAST_INSERT_ID();";
	$result = mysqli_query ($dbconn, $query);
	if (!$result) {Fatal_SQL_Error($query);}
	$row = mysqli_fetch_row($result);
	$syrsid = $row[0];

	// now add the value(s)
	for ($i = 0; $i < count($values); $i++)
	{
		$query = "INSERT INTO SysRefs_Values (SYRV_SYRS_ID, SYRV_DataLabelID, SYRV_DataType, SYRV_DataValue)"
			   . "\n VALUES"
			   . "\n ($syrsid, ($i+1), 'S', '{$values[$i]}');";
		if (!$dbconn->query ($query)) {Fatal_SQL_Error($query);}
	}
}

///////////////////////////////////////////////////////////////////////////////////
// Drop_Table
//
// Delete one or more tables
//
// $tablename 	required [string]
//				full table name or, if $part2 is included, the second part(s) of
//				the table names
// $part2		optional [string] (or array of strings)
//				"part2" of table name(s) to be deleted
//				this (or these) will be appended to $tablename_
///////////////////////////////////////////////////////////////////////////////////

function Drop_Table ($tablename, $part2 = null)
{
	global $dbconn;

	switch (gettype($part2))
	{
		case "string":
			{
				$part2 = array($part2);
				// fall thru
			}
		case "array" && count($part2) > 0:
			{
				foreach ($part2 as $tblsuffix)
				{
					$query = "DROP TABLE IF EXISTS $tablename" . "_$tblsuffix";
					if (!$dbconn->query ($query)) {Fatal_SQL_Error($query);}
				}
			}
		case "NULL":
			{
				$query = "DROP TABLE IF EXISTS $tablename";
				if (!$dbconn->query ($query)) {Fatal_SQL_Error($query);}
				break;
			}
	}
}

///////////////////////////////////////////////////////////////////////////////////
// Add_Table
//
// Create a database table
//
// $tblcode 	required [string]
//				acronym associated with the table; this will be used to construct
//				the file name within which the CREATE statement is to be found
//				(e.g., "table_create_$tblcode.sql")
///////////////////////////////////////////////////////////////////////////////////

function Add_Table($tblcode)
{
	global $dbconn;

	$query = file_get_contents("table_create_$tblcode.sql");
	if (!$dbconn->query ($query)) {Fatal_SQL_Error($query);}
}

///////////////////////////////////////////////////////////////////////////////////
// Add_StoredRoutine (procedure or function)
//
// Delete and create a database procedure
//
// $type		required [string]
//				should be "proc" or "func"
// $procname 	required [string]
//				name of the procedure itself. This will be used in the DROP statement
//				and as part of the file name within which the CREATE statement is
//				to be found (e.g., "proc_create_$procname.sql")
///////////////////////////////////////////////////////////////////////////////////

function Add_StoredRoutine($type, $rtnname)
{
	global $dbconn;

	$query = file_get_contents($type . "_create_$rtnname.sql");
	if (!$dbconn->multi_query ($query)) {Fatal_SQL_Error($query);}
	$result = $dbconn->next_result();
}

///////////////////////////////////////////////////////////////////////////////////
// Add_Audit_Triggers
//
// Define AFTER INSERT & AFTER UPDATE triggers to record the event in the audit log
//
// $table	 	required [string]
//				table name (e.g., "Language_Names")
// $code		required [string]
//				acronym associated with the table (e.g., "LNGN")
///////////////////////////////////////////////////////////////////////////////////

function Add_Audit_Triggers($table, $code)
{
	global $dbconn, $auditlog_insertrow, $auditlog_updaterow;

	$query  = "DROP TRIGGER IF EXISTS " . $code . "_OnRowInsert";
	if (!$dbconn->query ($query)) {Fatal_SQL_Error($query);}
	$query  = "CREATE TRIGGER $code" . "_OnRowInsert AFTER INSERT ON $table"
			  . "\nFOR EACH ROW INSERT INTO Audit_Log"
			  . "\n(AUDT_Type,AUDT_Timestamp,AUDT_Username,AUDT_UserIP1,AUDT_UserIP2,AUDT_ParentID,AUDT_ParentCode)"
			  . "\nVALUES"
			  . "\n($auditlog_insertrow,NEW.{$code}_UpdateTimestamp,NEW.{$code}_UpdateUser,NEW.{$code}_UpdateUserIP1,NEW.{$code}_UpdateUserIP2,NEW.{$code}_ID,'$code')";
	if (!$dbconn->query ($query)) {Fatal_SQL_Error($query);}

	$query  = "DROP TRIGGER IF EXISTS " . $code . "_OnRowUpdate";
	if (!$dbconn->query ($query)) {Fatal_SQL_Error($query);}
	$query  = "CREATE TRIGGER $code" . "_OnRowUpdate AFTER UPDATE ON $table"
			  . "\nFOR EACH ROW INSERT INTO Audit_Log"
			  . "\n(AUDT_Type,AUDT_Timestamp,AUDT_Username,AUDT_UserIP1,AUDT_UserIP2,AUDT_ParentID,AUDT_ParentCode)"
			  . "\nVALUES"
			  . "\n($auditlog_updaterow,NEW.{$code}_UpdateTimestamp,NEW.{$code}_UpdateUser,NEW.{$code}_UpdateUserIP1,NEW.{$code}_UpdateUserIP2,NEW.{$code}_ID, '$code')";
	if (!$dbconn->query ($query)) {Fatal_SQL_Error($query);}
}

?>
</body>
</html>